bool	Load_StartGame(char *filename);
bool	Load_Title(char *filename);
bool	Load_NarrationList(char *filename);
bool	Load_WaveList(char *filename);
bool	Load_MidiList(char *filename);
bool	Load_TalkList(char *filename);
bool	Load_ItemList(char *filename);
bool	Load_ShopList(char *filename);
bool	Load_LevelList(char *filename);
bool	Load_LevelAbilityList(char *filename);
bool	Load_MonsterList(char *filename);
bool	Load_EnemyList(char *filename);
bool	Load_MagicList(char *filename);
bool	Load_BackImageFileName(char *filename);
bool	Load_SelImageFileName(char *filename);
bool	Load_FaceImageFileName(char *filename);
bool	Load_EffectFileName(char *filename);
bool	Load_MapAnimFileName(char *filename);
bool	Load_TreasureList(char *filename);
bool	Load_PC(char *filename);
bool	Load_NpcList(char *filename);
bool	Load_SceneData(char *filename);
bool	Load_Setting(char *filename);
bool	Load_Prepare(char *filename);
void	Init_EffectData();
void	Init_MapAnimData();
void	Init_PcData();
void	Init_SceneData();
void	Term_RpgFile();

// Q[ݒ̓ǂݍ
bool Load_StartGame(char *filename)
{
	int  flag = 0;
	char ss[READ_LEN_MAX1];
	
	FILE *file1 = fopen(filename, "r");
	
	if(!file1){
		return false;
	}
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// Q[X^[g̏ʔԍ
		if(!strcmp(ss,"<start_scene_index>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</start_scene_index>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss, "%d", &gIdxScene);
		}
	}
	fclose(file1);
	
	return true;
}// Load_StartGame

// ^Cgݒ̓ǂݍ
bool Load_Title(char *filename)
{
	int  flag = 0, menu_item_ct = 0;
	char ss[READ_LEN_MAX1];
	
	FILE *file1 = fopen(filename, "r");
	
	if(!file1){
		return false;
	}
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// ^Cg f[^
		if(!strcmp(ss,"<midi_index>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</midi_index>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss, "%d", &g_t.idxMidi);
		}
		else if(!strcmp(ss,"<menu_pos>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</menu_pos>")){
			flag = 0;
		}
		else if(flag == 2){
			sscanf(ss, "%d %d", &g_t.ptSelect.x, &g_t.ptSelect.y);
		}
		else if(!strcmp(ss,"<menu_item_height>")){
			flag = 3;
		}
		else if(!strcmp(ss,"</menu_item_height>")){
			flag = 0;
		}
		else if(flag == 3){
			sscanf(ss, "%d", &g_t.hgtSelect);
		}
		else if(!strcmp(ss,"<font_size>")){
			flag = 4;
		}
		else if(!strcmp(ss,"</font_size>")){
			flag = 0;
		}
		else if(flag == 4){
			sscanf(ss, "%d", &g_t.sizeFont);
		}
		else if(!strcmp(ss,"<font_color>")){
			flag = 5;
		}
		else if(!strcmp(ss,"</font_color>")){
			flag = 0;
		}
		else if(flag == 5){
			sscanf(ss, "%d %d %d %d %d %d %d %d %d %d %d %d",
					&g_t.colorFont[0].red,
					&g_t.colorFont[0].green,
					&g_t.colorFont[0].blue,
					&g_t.colorFont[1].red,
					&g_t.colorFont[1].green,
					&g_t.colorFont[1].blue,
					&g_t.colorFont[2].red,
					&g_t.colorFont[2].green,
					&g_t.colorFont[2].blue,
					&g_t.colorFont[3].red,
					&g_t.colorFont[3].green,
					&g_t.colorFont[3].blue);
		}
		else if(!strcmp(ss,"<menu_item_number>")){
			flag = 6;
		}
		else if(!strcmp(ss,"</menu_item_number>")){
			flag = 0;
		}
		else if(flag == 6){
			sscanf(ss, "%d", &g_t.nSelect);
			if(g_t.nSelect > TITLE_ITEM_MAX){
				g_t.nSelect = TITLE_ITEM_MAX;
			}
		}
		else if(!strcmp(ss,"<menu_item_data>")){
			flag = 7;
		}
		else if(!strcmp(ss,"</menu_item_data>")){
			flag = 0;
		}
		else if(flag == 7){
			if(menu_item_ct < g_t.nSelect){
				sscanf(ss, "%d %d %s", &g_t.bFadeOutSelect[menu_item_ct],
										&g_t.idxSelect[menu_item_ct],
										g_t.strSelect[menu_item_ct]);
				menu_item_ct ++;
			}
		}
	}
	fclose(file1);
	
	return true;
}// Load_Title

// i[V Xg̓ǂݍ
bool Load_NarrationList(char *filename)
{
	int  flag = 0,narration_ct = 0;
	char ss[READ_LEN_MAX1];
	
	FILE *file1 = fopen(filename, "r");
	
	if(!file1){
		return false;
	}
	
	if(g_n.inf){
		SAFE_FREE(g_n.inf);
	}
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// i[V f[^̌
		if(!strcmp(ss,"<narration_number>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</narration_number>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d", &g_n.num);
			int size = sizeof(NARRATION) * g_n.num;
			g_n.inf = (LPNARRATION) malloc(size);
			if(g_n.inf)
				ZeroMemory(g_n.inf, size);
		}
		// i[V C f[^
		else if(!strcmp(ss,"<narration_data>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</narration_data>")){
			flag = 0;
		}
		else if(flag == 2){
			if(g_n.inf && narration_ct < g_n.num){
				sscanf(ss, "%d %d %d %d %d %d %d %d %d %d %d %d %s %d",
									&g_n.inf[narration_ct].idxTalk,
									&g_n.inf[narration_ct].sizeFont,
									&g_n.inf[narration_ct].colorFont.red,
									&g_n.inf[narration_ct].colorFont.green,
									&g_n.inf[narration_ct].colorFont.blue,
									&g_n.inf[narration_ct].rcTalk.left,
									&g_n.inf[narration_ct].rcTalk.top,
									&g_n.inf[narration_ct].rcTalk.right,
									&g_n.inf[narration_ct].rcTalk.bottom,
									&g_n.inf[narration_ct].nLetterSpeed,
									&g_n.inf[narration_ct].nWaitTime1,
									&g_n.inf[narration_ct].nWaitTime2,
									g_n.inf[narration_ct].nameImg,
									&g_n.inf[narration_ct].idxMidi);
									
					narration_ct ++;
			}
		}
	}
	fclose(file1);
	
	return true;
}// Load_NarrationList

// ʉXg̓ǂݍ
bool Load_WaveList(char *filename)
{
	int  flag = 0,wave_ct = 0;
	char ss[READ_LEN_MAX1];
	
	ZeroMemory(&g_snd, sizeof(g_snd));
	
	FILE *file1 = fopen(filename, "r");
	
	if(!file1){
		return false;
	}
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// ʉf[^̌
		if(!strcmp(ss,"<wave_number>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</wave_number>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d", &g_snd.num);
			if(g_snd.num > SOUND_MAX){
				g_snd.num = SOUND_MAX;
			}
		}
		// ʉf[^
		else if(!strcmp(ss,"<wave_data>")){
			flag = 2;
			wave_ct = 0;
		}
		else if(!strcmp(ss,"</wave_data>")){
			flag = 0;
		}
		else if(flag == 2){
			if(wave_ct < g_snd.num){
				strncpy(g_snd.name[wave_ct], ss, sizeof(g_snd.name[wave_ct]));
				wave_ct ++;
			}
		}
	}
	fclose(file1);
	
	return true;
}// Load_WaveList

// MIDI Xg̓ǂݍ
bool Load_MidiList(char *filename)
{
	int  flag = 0,midi_ct = 0;
	char ss[READ_LEN_MAX1];
	
	ZeroMemory(&g_bgm, sizeof(g_bgm));
	
	FILE *file1 = fopen(filename, "r");
	
	if(!file1){
		return false;
	}
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// MIDI f[^̌
		if(!strcmp(ss,"<midi_number>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</midi_number>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d",&g_bgm.num);
			if(g_bgm.num > BGM_MAX){
				g_bgm.num = BGM_MAX;
			}
		}
		// MIDI f[^
		else if(!strcmp(ss,"<midi_data>")){
			flag = 2;
			midi_ct = 0;
		}
		else if(!strcmp(ss,"</midi_data>")){
			flag = 0;
		}
		else if(flag == 2){
			if(midi_ct < g_bgm.num){
				strncpy(g_bgm.name[midi_ct], ss, sizeof(g_bgm.name[midi_ct]));
				midi_ct ++;
			}
		}
	}
	fclose(file1);
	
	return true;
}// Load_MidiList

// bXg̓ǂݍ
bool Load_TalkList(char *filename)
{
	int  i,flag = 0,talk_ct = 0;
	char ss[READ_LEN_MAX2];
	
	FILE *file1 = fopen(filename, "r");
	
	if(!file1){
		return false;
	}
	
	if(g_talk.str){
		for(i=0;i<g_talk.num;i++){
			SAFE_FREE(g_talk.str[i]);
		}
		SAFE_FREE(g_talk.str);
	}
	g_talk.num = 0;
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// bf[^̌
		if(!strcmp(ss,"<talk_number>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</talk_number>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d",&g_talk.num);
			int size = sizeof(char*) * g_talk.num;
			g_talk.str = (char**) malloc(size);
			if(g_talk.str)
				ZeroMemory(g_talk.str, size);
		}
		// bf[^
		else if(!strcmp(ss,"<talk_data>")){
			flag = 2;
			talk_ct = 0;
		}
		else if(!strcmp(ss,"</talk_data>")){
			flag = 0;
			g_talk.num = talk_ct;
		}
		else if(flag == 2){
			if(g_talk.str){
				if(talk_ct < g_talk.num){
					int		len = strlen(ss);
					g_talk.str[talk_ct] = (char*) malloc(len + 1);
					if(g_talk.str[talk_ct]){
						strncpy(g_talk.str[talk_ct], ss, len);
						g_talk.str[talk_ct][len] = '\0';
						talk_ct ++;
					}
				}
			}
		}
	}
	fclose(file1);
	
	return true;
}// Load_TalkList

// ACeXg̓ǂݍ
bool Load_ItemList(char *filename)
{
	int  flag = 0,item_ct = 0;
	char ss[READ_LEN_MAX2];
	
	FILE *file1 = fopen(filename,"r");
	
	if(!file1){
		return false;
	}
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// ACě
		if(!strcmp(ss,"<item_number>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</item_number>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d",&g_item.num);
			SAFE_FREE(g_item.inf);
			int size = sizeof(ITEM) * g_item.num;
			g_item.inf = (LPITEM) malloc(size);
			if(g_item.inf)
				ZeroMemory(g_item.inf, size);
		}
		
		// ACẽf[^
		else if(!strcmp(ss,"<item_data>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</item_data>")){
			flag = 0;
		}
		else if(flag == 2){
			if(g_item.inf){
				if(item_ct < g_item.num){
					sscanf(ss,"%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %s %s",
										&g_item.inf[item_ct].type,
										&g_item.inf[item_ct].flagNoJunk,
										&g_item.inf[item_ct].ability2.agility,
										&g_item.inf[item_ct].ability2.evade,
										&g_item.inf[item_ct].ability2.attack,
										&g_item.inf[item_ct].ability2.magicPower,
										&g_item.inf[item_ct].ability2.defense,
										&g_item.inf[item_ct].ability2.magicDefense,
										&g_item.inf[item_ct].ability2.hitPointMax,
										&g_item.inf[item_ct].ability2.mentalPointMax,
										&g_item.inf[item_ct].ability2.hitPoint,
										&g_item.inf[item_ct].ability2.mentalPoint,
										&g_item.inf[item_ct].ability2.condition,
										&g_item.inf[item_ct].idxEffect,
										&g_item.inf[item_ct].idxWave,
										&g_item.inf[item_ct].money,
										g_item.inf[item_ct].name,
										g_item.inf[item_ct].exp);
					for(unsigned int i=0;i<strlen(g_item.inf[item_ct].exp);i++){
						if(g_item.inf[item_ct].exp[i] == '#'){
							g_item.inf[item_ct].exp[i] = '\n';
						}
					}
					item_ct ++;
				}
			}
		}
	}
	
	fclose(file1);
	
	return true;
}// Load_ItemList

// VbvXgǂݍ
bool Load_ShopList(char *filename)
{
	int  i,flag = 0,shop_ct = 0,item_index_ct = 0;
	char ss[READ_LEN_MAX1];
	
	FILE *file1 = fopen(filename,"r");
	
	if(!file1){
		return false;
	}
	
	if(g_shop.inf){
		for(i=0;i<g_shop.num;i++){
			SAFE_FREE(g_shop.inf[i].item_index);
		}
		SAFE_FREE(g_shop.inf);
	}
	g_shop.num = 0;
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// X̐
		if(!strcmp(ss,"<shop_number>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</shop_number>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d",&g_shop.num);
			int size = sizeof(SHOP) * g_shop.num;
			g_shop.inf = (LPSHOP) malloc(size);
			if(g_shop.inf)
				ZeroMemory(g_shop.inf, size);
		}
		// X̃JEg
		else if(!strcmp(ss,"</shop_data>")){
			shop_ct ++;
		}
		// X̎
		else if(!strcmp(ss,"<kind>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</kind>")){
			flag = 0;
		}
		else if(flag == 2){
			if(g_shop.inf && shop_ct < g_shop.num){
				sscanf(ss,"%d",&g_shop.inf[shop_ct].kind);
			}
		}
		// wi摜t@Cij
		else if(!strcmp(ss,"<filename_bg_buy>")){
			flag = 3;
		}
		else if(!strcmp(ss,"</filename_bg_buy>")){
			flag = 0;
		}
		else if(flag == 3){
			if(g_shop.inf && shop_ct < g_shop.num){
				strncpy(g_shop.inf[shop_ct].filenameBgBuy, ss, sizeof(g_shop.inf[shop_ct].filenameBgBuy));
			}
		}
		// wi摜t@Cij
		else if(!strcmp(ss,"<filename_bg_sell>")){
			flag = 4;
		}
		else if(!strcmp(ss,"</filename_bg_sell>")){
			flag = 0;
		}
		else if(flag == 4){
			if(g_shop.inf && shop_ct < g_shop.num){
				strncpy(g_shop.inf[shop_ct].filenameBgSell, ss, sizeof(g_shop.inf[shop_ct].filenameBgSell));
			}
		}
		// ACeԍ̌
		else if(!strcmp(ss,"<item_number>")){
			flag = 5;
		}
		else if(!strcmp(ss,"</item_number>")){
			flag = 0;
		}
		else if(flag == 5){
			if(g_shop.inf && shop_ct < g_shop.num){
				sscanf(ss,"%d",&g_shop.inf[shop_ct].item_num);
				int size = sizeof(int) * g_shop.inf[shop_ct].item_num;
				g_shop.inf[shop_ct].item_index = (LPINT) malloc(size);
				if(g_shop.inf[shop_ct].item_index)
					ZeroMemory(g_shop.inf[shop_ct].item_index, size);
			}
		}
		// ACeԍ
		else if(!strcmp(ss,"<item_index>")){
			flag = 6;
			item_index_ct = 0;
		}
		else if(!strcmp(ss,"</item_index>")){
			flag = 0;
		}
		else if(flag == 6){
			if(g_shop.inf && shop_ct < g_shop.num){
				if(g_shop.inf[shop_ct].item_index && item_index_ct < g_shop.inf[shop_ct].item_num){
					sscanf(ss,"%d",&g_shop.inf[shop_ct].item_index[item_index_ct]);
					item_index_ct ++;
				}
			}
		}
	}
	
	fclose(file1);
	
	return true;
}// Load_ShopList

// xf[^ǂݍ
bool Load_LevelList(char *filename)
{
	int  flag = 0,level_ct = 0;
	char ss[READ_LEN_MAX1];
	
	FILE *file1 = fopen(filename,"r");
	
	if(!file1){
		return false;
	}
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// x̌
		if(!strcmp(ss,"<level_number>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</level_number>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d",&g_level.exp_num);
			SAFE_FREE(g_level.exp);
			int size = sizeof(LEVEL1) * g_level.exp_num;
			g_level.exp = (LPLEVEL1) malloc(size);
			if(g_level.exp)
				ZeroMemory(g_level.exp, size);
		}
		
		// x̃f[^
		else if(!strcmp(ss,"<level_data>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</level_data>")){
			flag = 0;
		}
		else if(flag == 2){
			if(g_level.exp){
				if(level_ct < g_level.exp_num){
					sscanf(ss,"%d %d",&g_level.exp[level_ct].level,
										&g_level.exp[level_ct].experiencePoint);
					level_ct ++;
				}
			}
		}
		// x̃f[^
		else if(!strcmp(ss,"<level_add>")){
			flag = 3;
		}
		else if(!strcmp(ss,"</level_add>")){
			flag = 0;
		}
		else if(flag == 3){
			sscanf(ss,"%d %d",&g_level.add.level,&g_level.add.experiencePoint);
		}
		// xől̃f[^
		else if(!strcmp(ss,"<level_max>")){
			flag = 4;
		}
		else if(!strcmp(ss,"</level_max>")){
			flag = 0;
		}
		else if(flag == 4){
			sscanf(ss,"%d",&g_level.max);
		}
	}
	
	
	fclose(file1);
	
	return true;
}// Load_LevelList

// xAbv̔\̓Abvlf[^ǂݍ
bool Load_LevelAbilityList(char *filename)
{
	int  flag = 0,la_ct = 0;
	char ss[READ_LEN_MAX1];
	
	FILE *file1 = fopen(filename,"r");
	
	if(!file1){
		return false;
	}
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// \̓Abvľ
		if(!strcmp(ss,"<level_ability_number>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</level_ability_number>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d",&g_lvlabl.num);
			SAFE_FREE(g_lvlabl.la);
			int size = sizeof(LEVELABILITY1) * g_lvlabl.num;
			g_lvlabl.la = (LPLEVELABILITY1) malloc(size);
			if(g_lvlabl.la)
				ZeroMemory(g_lvlabl.la, size);
		}
		
		// \̓Abvl̃f[^
		else if(!strcmp(ss,"<level_ability_data>")){
			flag = 2;
			la_ct = 0;
		}
		else if(!strcmp(ss,"</level_ability_data>")){
			flag = 0;
		}
		else if(flag == 2){
			if(g_lvlabl.la){
				if(la_ct < g_lvlabl.num){
					sscanf(ss,"%s %d %d %d %d %d %d %d %d",
										g_lvlabl.la[la_ct].name,
										&g_lvlabl.la[la_ct].value[0],
										&g_lvlabl.la[la_ct].value[1],
										&g_lvlabl.la[la_ct].value[2],
										&g_lvlabl.la[la_ct].value[3],
										&g_lvlabl.la[la_ct].value[4],
										&g_lvlabl.la[la_ct].value[5],
										&g_lvlabl.la[la_ct].value[6],
										&g_lvlabl.la[la_ct].value[7]);
					la_ct ++;
				}
			}
		}
		
		// \͒lAbv̕\
		else if(!strcmp(ss,"<level_ability_message>")){
			flag = 3;
		}
		else if(!strcmp(ss,"</level_ability_message>")){
			flag = 0;
		}
		else if(flag == 3){
			strncpy(g_lvlabl.str, ss, sizeof(g_lvlabl.str));
		}
	}
	
	fclose(file1);
	
	return true;
}// Load_LevelAbilityList

// f[^ǂݍ
bool Load_MonsterList(char *filename)
{
	int  flag = 0,monster_ct = 0;
	char ss[READ_LEN_MAX2];
	
	FILE *file1 = fopen(filename,"r");
	
	if(!file1){
		return false;
	}
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// ̌
		if(!strcmp(ss,"<monster_number>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</monster_number>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d",&g_monster.num);
			SAFE_FREE(g_monster.inf);
			int size = sizeof(MONSTER) * g_monster.num;
			g_monster.inf = (LPMONSTER) malloc(size);
			if(g_monster.inf)
				ZeroMemory(g_monster.inf, size);
		}
		// f[^
		else if(!strcmp(ss,"<monster_data>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</monster_data>")){
			flag = 0;
		}
		else if(flag == 2){
			if(g_monster.inf){
				if(monster_ct < g_monster.num){
					float rateSpecial1,rateSpecial2;
					sscanf(ss,"%d %d %d %d %d %d %d %d %d %d %d %f %f %d %d %d %d %s %d %d %s %d %d %d %d %d",
								&g_monster.inf[monster_ct].ability.agility,
								&g_monster.inf[monster_ct].ability.evade,
								&g_monster.inf[monster_ct].ability.attack,
								&g_monster.inf[monster_ct].ability.magicPower,
								&g_monster.inf[monster_ct].ability.defense,
								&g_monster.inf[monster_ct].ability.magicDefense,
								&g_monster.inf[monster_ct].ability.hitPointMax,
								&g_monster.inf[monster_ct].ability.mentalPointMax,
								&g_monster.inf[monster_ct].ability.condition,
								&g_monster.inf[monster_ct].ability.experiencePoint,
								&g_monster.inf[monster_ct].ability.money,
								&rateSpecial1,
								&rateSpecial2,
								&g_monster.inf[monster_ct].special,
								&g_monster.inf[monster_ct].damageSpecial,
								&g_monster.inf[monster_ct].flagAttack,
								&g_monster.inf[monster_ct].idxWave,
								g_monster.inf[monster_ct].name,
								&g_monster.inf[monster_ct].ptFocus.x,
								&g_monster.inf[monster_ct].ptFocus.y,
								g_monster.inf[monster_ct].fileName,
								&g_monster.inf[monster_ct].flag_alpha,
								&g_monster.inf[monster_ct].flag_colorkey,
								&g_monster.inf[monster_ct].colorkey_red,
								&g_monster.inf[monster_ct].colorkey_green,
								&g_monster.inf[monster_ct].colorkey_blue);
					g_monster.inf[monster_ct].rateSpecial1 = rateSpecial1;
					g_monster.inf[monster_ct].rateSpecial2 = rateSpecial2;
					monster_ct ++;
				}
			}
		}
	}
	
	fclose(file1);
	
	return true;
}// Load_MonsterList

// Gf[^ǂݍ
bool Load_EnemyList(char *filename)
{
	int  i,flag = 0,enemy_ct = 0,enemies_ct = 0;
	char ss[READ_LEN_MAX2];
	
	FILE *file1 = fopen(filename,"r");
	
	if(!file1){
		return false;
	}
	
	if(g_enemy.inf){
		for(i=0;i<g_enemy.num;i++){
			SAFE_FREE(g_enemy.inf[i].inf);
		}
		SAFE_FREE(g_enemy.inf);
	}
	g_enemy.num = 0;
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// Gjbǧ
		if(!strcmp(ss,"<enemy_number>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</enemy_number>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d",&g_enemy.num);
			int size = sizeof(ENEMIES2) * g_enemy.num;
			g_enemy.inf = (LPENEMIES2) malloc(size);
			if(g_enemy.inf)
				ZeroMemory(g_enemy.inf, size);
		}
		// Gjbg̃JEg
		else if(!strcmp(ss,"</enemy_data>")){
			enemy_ct ++;
		}
		// Ǧ
		else if(!strcmp(ss,"<enemies_number>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</enemies_number>")){
			flag = 0;
		}
		else if(flag == 2){
			if(g_enemy.inf && enemy_ct < g_enemy.num){
				sscanf(ss,"%d",&g_enemy.inf[enemy_ct].num);
				int size = sizeof(ENEMIES) * g_enemy.inf[enemy_ct].num;
				g_enemy.inf[enemy_ct].inf = (LPENEMIES) malloc(size);
				if(g_enemy.inf[enemy_ct].inf)
					ZeroMemory(g_enemy.inf[enemy_ct].inf, size);
			}
		}
		// Gf[^
		else if(!strcmp(ss,"<enemies_data>")){
			flag = 3;
			enemies_ct = 0;
		}
		else if(!strcmp(ss,"</enemies_data>")){
			flag = 0;
		}
		else if(flag == 3){
			if(g_enemy.inf && enemy_ct < g_enemy.num){
				if(g_enemy.inf[enemy_ct].inf && enemies_ct < g_enemy.inf[enemy_ct].num){
					float rateAppear,rateItem;
					sscanf(ss,"%d %d %d %d %d %d %d %f %f %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
										&g_enemy.inf[enemy_ct].inf[enemies_ct].monster[0].index,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].monster[1].index,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].monster[2].index,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].monster[3].index,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].monster[4].index,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].monster[5].index,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].idxBoss,
										&rateAppear,
										&rateItem,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].item.index,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].item.num,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].idxMidi,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].monster[0].pos.x,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].monster[0].pos.y,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].monster[1].pos.x,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].monster[1].pos.y,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].monster[2].pos.x,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].monster[2].pos.y,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].monster[3].pos.x,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].monster[3].pos.y,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].monster[4].pos.x,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].monster[4].pos.y,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].monster[5].pos.x,
										&g_enemy.inf[enemy_ct].inf[enemies_ct].monster[5].pos.y);
					g_enemy.inf[enemy_ct].inf[enemies_ct].item.index ++;
					g_enemy.inf[enemy_ct].inf[enemies_ct].rateAppear = rateAppear ;
					g_enemy.inf[enemy_ct].inf[enemies_ct].rateItem = rateItem;
					enemies_ct ++;
				}
			}
		}
	}
	
	fclose(file1);
	
	return true;
}// Load_EnemyList

// @f[^ǂݍ
bool Load_MagicList(char *filename)
{
	int  flag = 0,magic_ct = 0;
	char ss[READ_LEN_MAX2];
	
	FILE *file1 = fopen(filename,"r");
	
	if(!file1){
		return false;
	}
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// @̌
		if(!strcmp(ss,"<magic_number>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</magic_number>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d",&g_magic.num);
			SAFE_FREE(g_magic.inf);
			int size = sizeof(MAGIC) * g_magic.num;
			g_magic.inf = (LPMAGIC) malloc(size);
			if(g_magic.inf)
				ZeroMemory(g_magic.inf, size);
		}
		
		// @̃f[^
		else if(!strcmp(ss,"<magic_data>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</magic_data>")){
			flag = 0;
		}
		else if(flag == 2){
			if(g_magic.inf){
				if(magic_ct < g_magic.num){
					sscanf(ss,"%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %s %s",
										&g_magic.inf[magic_ct].flag_feasible,
										&g_magic.inf[magic_ct].flag_all,
										&g_magic.inf[magic_ct].damage,
										&g_magic.inf[magic_ct].ability2.agility,
										&g_magic.inf[magic_ct].ability2.evade,
										&g_magic.inf[magic_ct].ability2.attack,
										&g_magic.inf[magic_ct].ability2.magicPower,
										&g_magic.inf[magic_ct].ability2.defense,
										&g_magic.inf[magic_ct].ability2.magicDefense,
										&g_magic.inf[magic_ct].ability2.hitPointMax,
										&g_magic.inf[magic_ct].ability2.mentalPointMax,
										&g_magic.inf[magic_ct].ability2.hitPoint,
										&g_magic.inf[magic_ct].ability2.mentalPoint,
										&g_magic.inf[magic_ct].ability2.condition,
										&g_magic.inf[magic_ct].spendMP,
										&g_magic.inf[magic_ct].level,
										&g_magic.inf[magic_ct].idxEffect,
										&g_magic.inf[magic_ct].idxWave,
										g_magic.inf[magic_ct].name,
										g_magic.inf[magic_ct].exp);
					for(unsigned int i=0;i<strlen(g_magic.inf[magic_ct].exp);i++){
						if(g_magic.inf[magic_ct].exp[i] == '#'){
							g_magic.inf[magic_ct].exp[i] = '\n';
						}
					}
					magic_ct ++;
				}
			}
		}
	}
	
	fclose(file1);
	
	return true;
}// Load_MagicList

// wi摜t@C̓ǂݍ
bool Load_BackImageFileName(char *filename)
{
	int  flag = 0,image_back_ct = 0;
	char ss[READ_LEN_MAX1];
	
	FILE *file1 = fopen(filename, "r");
	
	if(!file1){
		return false;
	}
	
	g_inb.num = 0;
	SAFE_FREE(g_inb.inf);
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// wi摜t@C f[^̌
		if(!strcmp(ss,"<image_back_number>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</image_back_number>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d", &g_inb.num);
			int size = g_inb.num * sizeof(IMGINF);
			g_inb.inf = (LPIMGINF) malloc(size);
			if(g_inb.inf)
				ZeroMemory(g_inb.inf, size);
		}
		// wi摜t@C f[^
		else if(!strcmp(ss,"<image_back_data>")){
			flag = 2;
			image_back_ct = 0;
		}
		else if(!strcmp(ss,"</image_back_data>")){
			flag = 0;
		}
		else if(flag == 2){
			if(g_inb.inf && image_back_ct < g_inb.num){
				sscanf(ss, "%s %d %d %d %d %d",
											g_inb.inf[image_back_ct].name,
											&g_inb.inf[image_back_ct].flag_alpha,
											&g_inb.inf[image_back_ct].flag_colorkey,
											&g_inb.inf[image_back_ct].colorkey_red,
											&g_inb.inf[image_back_ct].colorkey_green,
											&g_inb.inf[image_back_ct].colorkey_blue);
				image_back_ct ++;
			}
		}
	}
	fclose(file1);
	
	return true;
}// Load_BackImageFileName

// J[\摜t@C̓ǂݍ
bool Load_SelImageFileName(char *filename)
{
	int  flag = 0,image_sel_ct = 0;
	char ss[READ_LEN_MAX1];
	
	FILE *file1 = fopen(filename, "r");
	
	if(!file1){
		return false;
	}
	
	g_ins.num = 0;
	SAFE_FREE(g_ins.inf);
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// J[\摜t@C f[^̌
		if(!strcmp(ss,"<image_sel_number>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</image_sel_number>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d", &g_ins.num);
			int size = g_ins.num * sizeof(IMGINF);
			g_ins.inf = (LPIMGINF) malloc(size);
			if(g_ins.inf)
				ZeroMemory(g_ins.inf, size);
		}
		// J[\摜t@C f[^
		else if(!strcmp(ss,"<image_sel_data>")){
			flag = 2;
			image_sel_ct = 0;
		}
		else if(!strcmp(ss,"</image_sel_data>")){
			flag = 0;
		}
		else if(flag == 2){
			if(g_ins.inf && image_sel_ct < g_ins.num){
				sscanf(ss, "%s %d %d %d %d %d",
											g_ins.inf[image_sel_ct].name,
											&g_ins.inf[image_sel_ct].flag_alpha,
											&g_ins.inf[image_sel_ct].flag_colorkey,
											&g_ins.inf[image_sel_ct].colorkey_red,
											&g_ins.inf[image_sel_ct].colorkey_green,
											&g_ins.inf[image_sel_ct].colorkey_blue);
				image_sel_ct ++;
			}
		}
	}
	fclose(file1);
	
	return true;
}// Load_SelImageFileName

// 摜t@C̓ǂݍ
bool Load_FaceImageFileName(char *filename)
{
	int  flag = 0,image_face_ct = 0;
	char ss[READ_LEN_MAX1];
	
	FILE *file1 = fopen(filename, "r");
	
	if(!file1){
		return false;
	}
	
	g_inf.num = 0;
	SAFE_FREE(g_inf.inf);
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// 摜t@C f[^̌
		if(!strcmp(ss,"<image_face_number>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</image_face_number>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d", &g_inf.num);
			int size = g_inf.num * sizeof(IMGINF2);
			g_inf.inf = (LPIMGINF2) malloc(size);
			if(g_inf.inf)
				ZeroMemory(g_inf.inf, size);
		}
		// 摜t@C f[^
		else if(!strcmp(ss,"<image_face_data>")){
			flag = 2;
			image_face_ct = 0;
		}
		else if(!strcmp(ss,"</image_face_data>")){
			flag = 0;
		}
		else if(flag == 2){
			if(g_inf.inf && image_face_ct < g_inf.num){
				sscanf(ss, "%d %d %s %d %d %d %d %d %d %d %d %d",
											&g_inf.inf[image_face_ct].ptDest.x,
											&g_inf.inf[image_face_ct].ptDest.y,
											g_inf.inf[image_face_ct].name,
											&g_inf.inf[image_face_ct].flag_alpha,
											&g_inf.inf[image_face_ct].flag_colorkey,
											&g_inf.inf[image_face_ct].colorkey_red,
											&g_inf.inf[image_face_ct].colorkey_green,
											&g_inf.inf[image_face_ct].colorkey_blue,
											&g_inf.inf[image_face_ct].ptLoad.x,
											&g_inf.inf[image_face_ct].ptLoad.y,
											&g_inf.inf[image_face_ct].widthLoad,
											&g_inf.inf[image_face_ct].heightLoad);
				image_face_ct ++;
			}
		}
	}
	fclose(file1);
	
	return true;
}// Load_FaceImageFileName

// GtFNg摜t@C̓ǂݍ
bool Load_EffectFileName(char *filename)
{
	int  flag = 0,image_effect_ct = 0,image_effect_pos_ct = 0;
	char ss[READ_LEN_MAX1];
	
	FILE *file1 = fopen(filename, "r");
	
	if(!file1){
		return false;
	}
	
	Init_EffectData();
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// GtFNg摜t@C f[^̌
		if(!strcmp(ss,"<image_effect_number>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</image_effect_number>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d", &g_ine.num);
			int size = g_ine.num * sizeof(IMGINF5);
			g_ine.inf = (LPIMGINF5) malloc(size);
			if(g_ine.inf)
				ZeroMemory(g_ine.inf, size);
		}
		// GtFNg摜t@C f[^
		else if(!strcmp(ss,"<image_effect_main_data>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</image_effect_main_data>")){
			flag = 0;
		}
		else if(flag == 2){
			if(g_ine.inf && image_effect_ct < g_ine.num){
				sscanf(ss, "%d %d %d %d %d %d %s %d %d %d %d %d %d %d %d %d",
											&g_ine.inf[image_effect_ct].inf3.flag_over,
											&g_ine.inf[image_effect_ct].inf3.speed,
											&g_ine.inf[image_effect_ct].inf3.width,
											&g_ine.inf[image_effect_ct].inf3.height,
											&g_ine.inf[image_effect_ct].inf3.ptDest.x,
											&g_ine.inf[image_effect_ct].inf3.ptDest.y,
											g_ine.inf[image_effect_ct].inf3.name,
											&g_ine.inf[image_effect_ct].inf3.flag_alpha,
											&g_ine.inf[image_effect_ct].inf3.flag_colorkey,
											&g_ine.inf[image_effect_ct].inf3.colorkey_red,
											&g_ine.inf[image_effect_ct].inf3.colorkey_green,
											&g_ine.inf[image_effect_ct].inf3.colorkey_blue,
											&g_ine.inf[image_effect_ct].inf3.ptLoad.x,
											&g_ine.inf[image_effect_ct].inf3.ptLoad.y,
											&g_ine.inf[image_effect_ct].inf3.widthLoad,
											&g_ine.inf[image_effect_ct].inf3.heightLoad);
			}
		}
		// GtFNg摜ʒu
		else if(!strcmp(ss,"<image_effect_pos_number>")){
			flag = 3;
		}
		else if(!strcmp(ss,"</image_effect_pos_number>")){
			flag = 0;
		}
		else if(flag == 3){
			if(g_ine.inf && image_effect_ct < g_ine.num){
				sscanf(ss,"%d", &g_ine.inf[image_effect_ct].inf4.pos_num);
				int size = g_ine.inf[image_effect_ct].inf4.pos_num * sizeof(POSIMG);
				g_ine.inf[image_effect_ct].inf4.pos = (LPPOSIMG) malloc(size);
				if(g_ine.inf[image_effect_ct].inf4.pos)
					ZeroMemory(g_ine.inf[image_effect_ct].inf4.pos, size);
			}
		}
		// GtFNg摜ʒuf[^
		else if(!strcmp(ss,"<image_effect_pos_data>")){
			flag = 4;
			image_effect_pos_ct = 0;
		}
		else if(!strcmp(ss,"</image_effect_pos_data>")){
			flag = 0;
		}
		else if(flag == 4){
			if(g_ine.inf && image_effect_ct < g_ine.num && g_ine.inf[image_effect_ct].inf4.pos &&
				image_effect_pos_ct < g_ine.inf[image_effect_ct].inf4.pos_num)
			{
				sscanf(ss, "%d %d %d %d",	&g_ine.inf[image_effect_ct].inf4.pos[image_effect_pos_ct].posImg.x,
											&g_ine.inf[image_effect_ct].inf4.pos[image_effect_pos_ct].posImg.y,
											&g_ine.inf[image_effect_ct].inf4.pos[image_effect_pos_ct].ptDst.x,
											&g_ine.inf[image_effect_ct].inf4.pos[image_effect_pos_ct].ptDst.y);
				image_effect_pos_ct ++;
			}
		}
		// GtFNg̃JEg
		else if(!strcmp(ss,"</image_effect_data>")){
			image_effect_ct ++;
		}
	}
	fclose(file1);
	
	return true;
}// Load_EffectFileName

// }bv`bvAj̓ǂݍ
bool Load_MapAnimFileName(char *filename)
{
	int  flag = 0,map_anim_ct = 0,map_anim_pos_ct = 0;
	char ss[READ_LEN_MAX1];
	
	Init_MapAnimData();
	
	FILE *file1 = fopen(filename, "r");
	
	if(!file1){
		return false;
	}
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// }bv`bvAj
		if(!strcmp(ss,"<map_anim_main_data>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</map_anim_main_data>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss, "%d %d %d %s",	&g_inma.speed,
										&g_inma.width,
										&g_inma.height,
										g_inma.name);
		}
		// }bv`bvAǰ
		else if(!strcmp(ss,"<map_anim_number>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</map_anim_number>")){
			flag = 0;
		}
		else if(flag == 2){
			sscanf(ss,"%d", &g_inma.inf_num);
			int size = g_inma.inf_num * sizeof(IMGINF6);
			g_inma.inf = (LPIMGINF6) malloc(size);
			if(g_inma.inf)
				ZeroMemory(g_inma.inf, size);
		}
		// }bv`bvAj摜ʒu
		else if(!strcmp(ss,"<map_anim_pos_number>")){
			flag = 3;
			map_anim_pos_ct = 0;
		}
		else if(!strcmp(ss,"</map_anim_pos_number>")){
			flag = 0;
		}
		else if(flag == 3){
			sscanf(ss,"%d", &g_inma.inf[map_anim_ct].pos_num);
			if(g_inma.inf && map_anim_pos_ct < g_inma.inf_num){
				int size = g_inma.inf[map_anim_ct].pos_num * sizeof(POINT);
				g_inma.inf[map_anim_ct].pos = (LPPOINT) malloc(size);
				if(g_inma.inf[map_anim_ct].pos)
					ZeroMemory(g_inma.inf[map_anim_ct].pos, size);
			}
		}
		// }bv`bvAj摜ʒuf[^
		else if(!strcmp(ss,"<map_anim_pos_data>")){
			flag = 4;
			map_anim_pos_ct = 0;
		}
		else if(!strcmp(ss,"</map_anim_pos_data>")){
			flag = 0;
		}
		else if(flag == 4){
			if(g_inma.inf && map_anim_ct < g_inma.inf_num && g_inma.inf[map_anim_ct].pos &&
				map_anim_pos_ct < g_inma.inf[map_anim_ct].pos_num)
			{
				sscanf(ss, "%d %d",	&g_inma.inf[map_anim_ct].pos[map_anim_pos_ct].x,
									&g_inma.inf[map_anim_ct].pos[map_anim_pos_ct].y);
				map_anim_pos_ct ++;
			}
		}
		// }bv`bvAj̃JEg
		else if(!strcmp(ss,"</map_anim_data>")){
			map_anim_ct ++;
		}
	}
	fclose(file1);
	
	return true;
}// Load_MapAnimFileName

// 󔠃f[^ǂݍ
bool Load_TreasureList(char *filename)
{
	bool ret = true;
	int  flag = 0,tre_ct = 0;
	char ss[READ_LEN_MAX2];
	
	FILE *file1 = fopen(filename,"r");
	
	if(!file1){
		return false;
	}
	
	SAFE_FREE(g_tre.inf);
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// 󔠂̌
		if(!strcmp(ss,"<treasure_number>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</treasure_number>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d",&g_tre.num);
			int size = sizeof(TREASURE) * g_tre.num;
			g_tre.inf = (LPTREASURE) malloc(size);
			if(g_tre.inf)
				ZeroMemory(g_tre.inf, size);
		}
		// 󔠂̃f[^
		else if(!strcmp(ss,"<treasure_data>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</treasure_data>")){
			flag = 0;
		}
		else if(flag == 2){
			if(g_tre.inf && tre_ct < g_tre.num){
				sscanf(ss,"%d %d %d %d %d %d %d %d %d",
										&g_tre.inf[tre_ct].flag_show,
										&g_tre.inf[tre_ct].flag_once,
										&g_tre.inf[tre_ct].flag_opened,
										&g_tre.inf[tre_ct].flag_anim_kind,
										&g_tre.inf[tre_ct].pt.x,
										&g_tre.inf[tre_ct].pt.y,
										&g_tre.inf[tre_ct].idxEffect,
										&g_tre.inf[tre_ct].idxWave,
										&g_tre.inf[tre_ct].idxFlag);
				
				tre_ct ++;
			}
			else{
				ret = false;
			}
		}
	}
	
	fclose(file1);
	
	return ret;
}// Load_TreasureList

// PC f[^̓ǂݍ
// ACeŏ珊ꍇ́AidxEquipment  item ̃ACeԍ + 1 
bool Load_PC(char *filename)
{
	int  flag = 0,equip_ct = 0,item_ct = 0,equip_max = 0;
	char ss[READ_LEN_MAX1];
	
	FILE *file1 = fopen(filename, "r");
	
	if(!file1){
		return false;
	}
	
	Init_PcData();
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// PC
		if(!strcmp(ss,"<pc_name>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</pc_name>")){
			flag = 0;
		}
		else if(flag == 1){
			strncpy(g_pc.name, ss, sizeof(g_pc.name));
		}
		// C f[^
		else if(!strcmp(ss,"<pc_main_data>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</pc_main_data>")){
			flag = 0;
		}
		else if(flag == 2){
			sscanf(ss,"%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
						&g_pc.move_speed,
						&g_pc.view.x, &g_pc.view.y, &g_pc.pos.x, &g_pc.pos.y, 
						&g_pc.posBm.x, &g_pc.posBm.y, &g_pc.idxDir, &g_pc.level,
						&g_pc.ability.agility, &g_pc.ability.evade, &g_pc.ability.attack, 
						&g_pc.ability.magicPower, &g_pc.ability.defense, &g_pc.ability.magicDefense,
						&g_pc.ability.hitPointMax, &g_pc.ability.mentalPointMax,
						&g_pc.ability.condition, &g_pc.ability.experiencePoint, 
						&g_pc.ability.money, &g_pc.damagePoison);
		}
		// L`bv摜f[^
		else if(!strcmp(ss,"<pc_chip_data>")){
			flag = 3;
		}
		else if(!strcmp(ss,"</pc_chip_data>")){
			flag = 0;
		}
		else if(flag == 3){
			sscanf(ss,"%s %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
							g_pc.img[0].filenameBm,
							&g_pc.img[0].xBm,
							&g_pc.img[0].yBm,
							&g_pc.img[0].widthBm,
							&g_pc.img[0].heightBm,
							&g_pc.img[0].flag_alpha,
							&g_pc.img[0].flag_colorkey,
							&g_pc.img[0].colorkey_red,
							&g_pc.img[0].colorkey_green,
							&g_pc.img[0].colorkey_blue,
							&g_pc.img_pos_idx[0][0],
							&g_pc.img_pos_idx[0][1],
							&g_pc.img_pos_idx[0][2],
							&g_pc.img_pos_idx[0][3],
							&g_pc.img_pos_idx[1][0],
							&g_pc.img_pos_idx[1][1],
							&g_pc.img_pos_idx[1][2],
							&g_pc.img_pos_idx[1][3]);
		}
		// 摜f[^
		else if(!strcmp(ss,"<pc_face_data>")){
			flag = 4;
		}
		else if(!strcmp(ss,"</pc_face_data>")){
			flag = 0;
		}
		else if(flag == 4){
			sscanf(ss,"%s %d %d %d %d %d %d %d %d %d",
							g_pc.img[1].filenameBm,
							&g_pc.img[1].xBm,
							&g_pc.img[1].yBm,
							&g_pc.img[1].widthBm,
							&g_pc.img[1].heightBm,
							&g_pc.img[1].flag_alpha,
							&g_pc.img[1].flag_colorkey,
							&g_pc.img[1].colorkey_red,
							&g_pc.img[1].colorkey_green,
							&g_pc.img[1].colorkey_blue);
		}
		// f[^̌
		else if(!strcmp(ss,"<pc_equipment_number>")){
			flag = 5;
		}
		else if(!strcmp(ss,"</pc_equipment_number>")){
			flag = 0;
		}
		else if(flag == 5){
			sscanf(ss,"%d", &equip_max);
			if(equip_max > EQUIP_NUM){
				equip_max = EQUIP_NUM;
			}
		}
		// f[^
		else if(!strcmp(ss,"<pc_equipment_data>")){
			flag = 6;
			equip_ct = 0;
		}
		else if(!strcmp(ss,"</pc_equipment_data>")){
			flag = 0;
		}
		else if(flag == 6){
			if(equip_ct < equip_max){
				sscanf(ss,"%d", &g_pc.idxEquipment[equip_ct]);
				equip_ct ++;
			}
		}
		// ACe f[^̍ő吔
		else if(!strcmp(ss,"<pc_item_max_number>")){
			flag = 7;
		}
		else if(!strcmp(ss,"</pc_item_max_number>")){
			flag = 0;
		}
		else if(flag == 7){
			sscanf(ss,"%d", &g_pc.numItemKindMax);
			SAFE_FREE(g_pc.item);
			int size = sizeof(ITEM3) * g_pc.numItemKindMax;
			g_pc.item = (LPITEM3) malloc(size);
			if(g_pc.item)
				ZeroMemory(g_pc.item, size);
		}
		// ACe f[^̌
		else if(!strcmp(ss,"<pc_item_number>")){
			flag = 8;
		}
		else if(!strcmp(ss,"</pc_item_number>")){
			flag = 0;
		}
		else if(flag == 8){
			sscanf(ss,"%d", &g_pc.numItemKind);
			if(g_pc.numItemKind >= g_pc.numItemKindMax){
				g_pc.numItemKind = g_pc.numItemKindMax;
			}
		}
		// ACe f[^
		else if(!strcmp(ss,"<pc_item_data>")){
			flag = 9;
			item_ct = 0;
		}
		else if(!strcmp(ss,"</pc_item_data>")){
			flag = 0;
		}
		else if(flag == 9){
			if(g_pc.item && item_ct < g_pc.numItemKind){
				sscanf(ss,"%d %d", &g_pc.item[item_ct].index, &g_pc.item[item_ct].num);
				item_ct ++;
			}
		}
	}
	fclose(file1);
	
	return true;
}// Load_PC

// NPC ̓ǂݍ
bool Load_NpcList(char *filename)
{
	int  flag = 0,npc_ct = 0;
	char ss[READ_LEN_MAX1];
	
	FILE *file1 = fopen(filename, "r");
	
	if(!file1){
		return false;
	}
	
	SAFE_FREE(g_npc.inf);
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// NPCf[^̌
		if(!strcmp(ss,"<npc_number>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</npc_number>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d",&g_npc.num);
			int size = sizeof(NPC) * g_npc.num;
			g_npc.inf = (LPNPC) malloc(size);
			if(g_npc.inf)
				ZeroMemory(g_npc.inf, size);
		}
		// NPCf[^
		else if(!strcmp(ss,"<npc_data>")){
			flag = 2;
			npc_ct = 0;
		}
		else if(!strcmp(ss,"</npc_data>")){
			flag = 0;
		}
		else if(flag == 2){
			if(g_npc.inf){
				if(npc_ct < g_npc.num){
					sscanf(ss,"%d %d %d %d %d %d %d %d %d %d %d %d %d %s %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %s",
											&g_npc.inf[npc_ct].typeMove,
											&g_npc.inf[npc_ct].idxDir,
											&g_npc.inf[npc_ct].flag_show,
											&g_npc.inf[npc_ct].move_speed,
											&g_npc.inf[npc_ct].posBm.x,
											&g_npc.inf[npc_ct].posBm.y,
											&g_npc.inf[npc_ct].posNow.x,
											&g_npc.inf[npc_ct].posNow.y,
											&g_npc.inf[npc_ct].posCenter.x,
											&g_npc.inf[npc_ct].posCenter.y,
											&g_npc.inf[npc_ct].areaMove.x,
											&g_npc.inf[npc_ct].areaMove.y,
											&g_npc.inf[npc_ct].idxFlag,
											g_npc.inf[npc_ct].img.filenameBm,
											&g_npc.inf[npc_ct].img.xBm,
											&g_npc.inf[npc_ct].img.yBm,
											&g_npc.inf[npc_ct].img.widthBm,
											&g_npc.inf[npc_ct].img.heightBm,
											&g_npc.inf[npc_ct].img.flag_alpha,
											&g_npc.inf[npc_ct].img.flag_colorkey,
											&g_npc.inf[npc_ct].img.colorkey_red,
											&g_npc.inf[npc_ct].img.colorkey_green,
											&g_npc.inf[npc_ct].img.colorkey_blue,
											&g_npc.inf[npc_ct].img_pos_idx[0][0],
											&g_npc.inf[npc_ct].img_pos_idx[0][1],
											&g_npc.inf[npc_ct].img_pos_idx[0][2],
											&g_npc.inf[npc_ct].img_pos_idx[0][3],
											&g_npc.inf[npc_ct].img_pos_idx[1][0],
											&g_npc.inf[npc_ct].img_pos_idx[1][1],
											&g_npc.inf[npc_ct].img_pos_idx[1][2],
											&g_npc.inf[npc_ct].img_pos_idx[1][3],
											g_npc.inf[npc_ct].name);
					npc_ct ++;
				}
			}
		}
	}
	fclose(file1);
	
	return true;
}// Load_NpcList

// ʃf[^ǂݍ
bool Load_SceneData(char *filename)
{
	int  flag = 0,scene_change_ct,npc_index_ct,tre_index_ct,battle_ct,bg_ct,event_pos_ct,flag_ct,flag_cmd_data_ct;
	char ss[READ_LEN_MAX2];
	
	FILE *file1 = fopen(filename,"r");
	
	if(!file1){
		return false;
	}
	
	Init_SceneData();	// ̉
	
	flag_ct = 0;
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// ʂ̎
		if(!strcmp(ss,"<scene_kind>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</scene_kind>")){
			flag = 0;
		}
		else if(flag == 2){
			sscanf(ss,"%d",&g_sn.kindScene);
		}
		// ʖ
		else if(!strcmp(ss,"<scene_name>")){
			flag = 3;
		}
		else if(!strcmp(ss,"</scene_name>")){
			flag = 0;
		}
		else if(flag == 3){
			strncpy(g_sn.scene_name, ss, sizeof(g_sn.scene_name));
		}
		// }bvf[^ t@C
		else if(!strcmp(ss,"<filename_map_data>")){
			flag = 4;
		}
		else if(!strcmp(ss,"</filename_map_data>")){
			flag = 0;
		}
		else if(flag == 4){
			sscanf(ss,"%s", g_sn.filenameMapData);
		}
		// wi}bv`bv t@C
		else if(!strcmp(ss,"<filename_bg_map_chip>")){
			flag = 5;
		}
		else if(!strcmp(ss,"</filename_bg_map_chip>")){
			flag = 0;
		}
		else if(flag == 5){
			sscanf(ss,"%s", g_sn.filenameBgMapChip);
		}
		// C[}bv`bv
		else if(!strcmp(ss,"<lyer_map_chip>")){
			flag = 6;
		}
		else if(!strcmp(ss,"</lyer_map_chip>")){
			flag = 0;
		}
		else if(flag == 6){
			sscanf(ss,"%s %d %d %d %d %d",
								g_sn.imginfLyerMapChip.name,
								&g_sn.imginfLyerMapChip.flag_alpha,
								&g_sn.imginfLyerMapChip.flag_colorkey,
								&g_sn.imginfLyerMapChip.colorkey_red,
								&g_sn.imginfLyerMapChip.colorkey_green,
								&g_sn.imginfLyerMapChip.colorkey_blue);
		}
		// MIDI t@Cԍ
		else if(!strcmp(ss,"<midi_index>")){
			flag = 7;
		}
		else if(!strcmp(ss,"</midi_index>")){
			flag = 0;
		}
		else if(flag == 7){
			sscanf(ss,"%d",&g_sn.idxMidi);
		}
		// ʕύXf[^̌
		else if(!strcmp(ss,"<scene_change_number>")){
			flag = 8;
		}
		else if(!strcmp(ss,"</scene_change_number>")){
			flag = 0;
		}
		else if(flag == 8){
			sscanf(ss,"%d",&g_sn.scene_change_num);
			int size = sizeof(SCENECHANGE) * g_sn.scene_change_num;
			g_sn.scene_change = (LPSCENECHANGE) malloc(size);
			if(g_sn.scene_change)
				ZeroMemory(g_sn.scene_change, size);
		}
		// ʕύXf[^
		else if(!strcmp(ss,"<scene_change_data>")){
			flag = 9;
			scene_change_ct = 0;
		}
		else if(!strcmp(ss,"</scene_change_data>")){
			flag = 0;
		}
		else if(flag == 9){
			if(g_sn.scene_change){
				if(scene_change_ct < g_sn.scene_change_num){
					sscanf(ss,"%d %d %d %d",
							&g_sn.scene_change[scene_change_ct].tipPtNow.x,
							&g_sn.scene_change[scene_change_ct].tipPtNow.y,
							&g_sn.scene_change[scene_change_ct].idxDir,
							&g_sn.scene_change[scene_change_ct].idxFlag);
					scene_change_ct ++;
				}
			}
		}
		// NPC ԍf[^̌
		else if(!strcmp(ss,"<npc_index_number>")){
			flag = 10;
		}
		else if(!strcmp(ss,"</npc_index_number>")){
			flag = 0;
		}
		else if(flag == 10){
			sscanf(ss,"%d",&g_sn.npc_index_num);
			int size = sizeof(int) * g_sn.npc_index_num;
			g_sn.npc_index = (LPINT) malloc(size);
			if(g_sn.npc_index)
				ZeroMemory(g_sn.npc_index, size);
		}
		// NPC ԍf[^
		else if(!strcmp(ss,"<npc_index_data>")){
			flag = 11;
			npc_index_ct = 0;
		}
		else if(!strcmp(ss,"</npc_index_data>")){
			flag = 0;
		}
		else if(flag == 11){
			if(g_sn.npc_index){
				if(npc_index_ct < g_sn.npc_index_num){
					sscanf(ss,"%d",&g_sn.npc_index[npc_index_ct]);
					npc_index_ct ++;
				}
			}
		}
		// 󔠔ԍf[^̌
		else if(!strcmp(ss,"<treasure_index_number>")){
			flag = 12;
		}
		else if(!strcmp(ss,"</treasure_index_number>")){
			flag = 0;
		}
		else if(flag == 12){
			sscanf(ss,"%d",&g_sn.tre_index_num);
			int size = sizeof(int) * g_sn.tre_index_num;
			g_sn.tre_index = (LPINT) malloc(size);
			if(g_sn.tre_index)
				ZeroMemory(g_sn.tre_index, size);
		}
		// 󔠔ԍf[^
		else if(!strcmp(ss,"<treasure_index_data>")){
			flag = 13;
			tre_index_ct = 0;
		}
		else if(!strcmp(ss,"</treasure_index_data>")){
			flag = 0;
		}
		else if(flag == 13){
			if(g_sn.tre_index){
				if(tre_index_ct < g_sn.tre_index_num){
					sscanf(ss,"%d",&g_sn.tre_index[tre_index_ct]);
					tre_index_ct ++;
				}
			}
		}
		// 퓬f[^̌
		else if(!strcmp(ss,"<battle_number>")){
			flag = 14;
		}
		else if(!strcmp(ss,"</battle_number>")){
			flag = 0;
		}
		else if(flag == 14){
			sscanf(ss,"%d",&g_sn.battle_num);
			int size = sizeof(BATTLE) * g_sn.battle_num;
			g_sn.battle = (LPBATTLE) malloc(size);
			if(g_sn.battle)
				ZeroMemory(g_sn.battle, size);
		}
		// 퓬f[^
		else if(!strcmp(ss,"<battle_data>")){
			flag = 15;
			battle_ct = 0;
		}
		else if(!strcmp(ss,"</battle_data>")){
			flag = 0;
		}
		else if(flag == 15){
			if(g_sn.battle && battle_ct < g_sn.battle_num){
				sscanf(ss,"%d %f %s",&g_sn.battle[battle_ct].idxEnemy
									,&g_sn.battle[battle_ct].rateAppear
									,g_sn.battle[battle_ct].filenameBgBattle);
				battle_ct ++;
			}
		}
		// }bv`bvɑΉ퓬̔ԍ+1
		else if(!strcmp(ss,"<battle_field_data>")){
			flag = 16;
			bg_ct = 0;
		}
		else if(!strcmp(ss,"</battle_field_data>")){
			flag = 0;
		}
		else if(flag == 16){
			if(bg_ct < sizeof(g_sn.battle_map.idxBattles)/sizeof(g_sn.battle_map.idxBattles[0])){
				sscanf(ss,"%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
										&g_sn.battle_map.idxBattles[bg_ct][0],
										&g_sn.battle_map.idxBattles[bg_ct][1],
										&g_sn.battle_map.idxBattles[bg_ct][2],
										&g_sn.battle_map.idxBattles[bg_ct][3],
										&g_sn.battle_map.idxBattles[bg_ct][4],
										&g_sn.battle_map.idxBattles[bg_ct][5],
										&g_sn.battle_map.idxBattles[bg_ct][6],
										&g_sn.battle_map.idxBattles[bg_ct][7],
										&g_sn.battle_map.idxBattles[bg_ct][8],
										&g_sn.battle_map.idxBattles[bg_ct][9],
										&g_sn.battle_map.idxBattles[bg_ct][10],
										&g_sn.battle_map.idxBattles[bg_ct][11],
										&g_sn.battle_map.idxBattles[bg_ct][12],
										&g_sn.battle_map.idxBattles[bg_ct][13],
										&g_sn.battle_map.idxBattles[bg_ct][14],
										&g_sn.battle_map.idxBattles[bg_ct][15]);
				bg_ct ++;
			}
		}
		// }bv`bvAj t@C
		else if(!strcmp(ss,"<anim_field_filename>")){
			flag = 17;
		}
		else if(!strcmp(ss,"</anim_field_filename>")){
			flag = 0;
		}
		else if(flag == 17){
			sscanf(ss,"%s", g_sn.filenameMapAnim);
		}
		// }bv`bvAj̃GtFNgԍ+1
		else if(!strcmp(ss,"<anim_field_data>")){
			flag = 18;
			bg_ct = 0;
		}
		else if(!strcmp(ss,"</anim_field_data>")){
			flag = 0;
		}
		else if(flag == 18){
			if(bg_ct < sizeof(g_sn.map_anim.idxMapAnims)/sizeof(g_sn.map_anim.idxMapAnims[0])){
				sscanf(ss,"%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
										&g_sn.map_anim.idxMapAnims[bg_ct][0],
										&g_sn.map_anim.idxMapAnims[bg_ct][1],
										&g_sn.map_anim.idxMapAnims[bg_ct][2],
										&g_sn.map_anim.idxMapAnims[bg_ct][3],
										&g_sn.map_anim.idxMapAnims[bg_ct][4],
										&g_sn.map_anim.idxMapAnims[bg_ct][5],
										&g_sn.map_anim.idxMapAnims[bg_ct][6],
										&g_sn.map_anim.idxMapAnims[bg_ct][7],
										&g_sn.map_anim.idxMapAnims[bg_ct][8],
										&g_sn.map_anim.idxMapAnims[bg_ct][9],
										&g_sn.map_anim.idxMapAnims[bg_ct][10],
										&g_sn.map_anim.idxMapAnims[bg_ct][11],
										&g_sn.map_anim.idxMapAnims[bg_ct][12],
										&g_sn.map_anim.idxMapAnims[bg_ct][13],
										&g_sn.map_anim.idxMapAnims[bg_ct][14],
										&g_sn.map_anim.idxMapAnims[bg_ct][15]);
				bg_ct ++;
			}
		}
		// ʒuCxg f[^̌
		else if(!strcmp(ss,"<event_pos_number>")){
			flag = 19;
		}
		else if(!strcmp(ss,"</event_pos_number>")){
			flag = 0;
		}
		else if(flag == 19){
			sscanf(ss,"%d",&g_sn.event_pos_num);
			int size = sizeof(EVENTPOS) * g_sn.event_pos_num;
			g_sn.event_pos = (LPEVENTPOS) malloc(size);
			if(g_sn.event_pos)
				ZeroMemory(g_sn.event_pos, size);
		}
		// ʒuCxg f[^
		else if(!strcmp(ss,"<event_pos_data>")){
			flag = 20;
			event_pos_ct = 0;
		}
		else if(!strcmp(ss,"</event_pos_data>")){
			flag = 0;
		}
		else if(flag == 20){
			if(g_sn.event_pos && event_pos_ct < g_sn.event_pos_num){
				sscanf(ss,"%d %d %d %d %d %d",
										&g_sn.event_pos[event_pos_ct].kind,
										&g_sn.event_pos[event_pos_ct].pos.x,
										&g_sn.event_pos[event_pos_ct].pos.y,
										&g_sn.event_pos[event_pos_ct].idxDir,
										&g_sn.event_pos[event_pos_ct].idxFlag,
										&g_sn.event_pos[event_pos_ct].idxEvent);
				event_pos_ct ++;
			}
		}
		// CxgR}ȟ
		else if(!strcmp(ss,"<flag_number>")){
			flag = 21;
		}
		else if(!strcmp(ss,"</flag_number>")){
			flag = 0;
		}
		else if(flag == 21){
			sscanf(ss,"%d", &g_sn.evt_cmd_num);
			int size = sizeof(EVENTCMDSTR) * g_sn.evt_cmd_num;
			g_sn.evt_cmd = (LPEVENTCMDSTR) malloc(size);
			if(g_sn.evt_cmd)
				ZeroMemory(g_sn.evt_cmd, size);
		}
		// eCxgR}h̍s
		else if(!strcmp(ss,"<flag_cmd_number>")){
			flag = 22;
		}
		else if(!strcmp(ss,"</flag_cmd_number>")){
			flag = 0;
		}
		else if(flag == 22){
			if(g_sn.evt_cmd && flag_ct < g_sn.evt_cmd_num){
				sscanf(ss,"%d", &g_sn.evt_cmd[flag_ct].num);
				int size = sizeof(char*) * g_sn.evt_cmd[flag_ct].num;
				g_sn.evt_cmd[flag_ct].str = (char**) malloc(size);
				if(g_sn.evt_cmd[flag_ct].str)
					ZeroMemory(g_sn.evt_cmd[flag_ct].str, size);
			}
		}
		// CxgR}h
		else if(!strcmp(ss,"<flag_cmd_data>")){
			flag = 23;
			flag_cmd_data_ct = 0;
		}
		else if(!strcmp(ss,"</flag_cmd_data>")){
			flag = 0;
			flag_ct ++;
		}
		else if(flag == 23){
			if(g_sn.evt_cmd && flag_ct < g_sn.evt_cmd_num && 
				g_sn.evt_cmd[flag_ct].str && flag_cmd_data_ct < g_sn.evt_cmd[flag_ct].num)
			{
				int	len = strlen(ss);
				g_sn.evt_cmd[flag_ct].str[flag_cmd_data_ct] = (char*) malloc(len + 1);
				strncpy(g_sn.evt_cmd[flag_ct].str[flag_cmd_data_ct], ss, len);
				g_sn.evt_cmd[flag_ct].str[flag_cmd_data_ct][len] = '\0';
				flag_cmd_data_ct ++;
			}
		}
	}
	
	fclose(file1);
	
	return true;
}// Load_SceneData

// {ݒ̓ǂݍ
bool Load_Setting(char *filename)
{
	int  flag = 0, color_ct = 0;
	char ss[READ_LEN_MAX1];
	
	FILE *file1 = fopen(filename, "r");
	
	if(!file1){
		return false;
	}
	
	ZeroMemory(&g_set, sizeof(g_set));
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// Q[
		if(!strcmp(ss,"<title>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</title>")){
			flag = 0;
		}
		else if(flag == 1){
			strncpy(g_set.title, ss, sizeof(g_set.title));
		}
		// 퓬tH[JX摜
		else if(!strcmp(ss,"<img_focus>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</img_focus>")){
			flag = 0;
		}
		else if(flag == 2){
			sscanf(ss,"%s %d %d %d %d %d",	g_set.img_focus.name,
											&g_set.img_focus.flag_alpha,
											&g_set.img_focus.flag_colorkey,
											&g_set.img_focus.colorkey_red,
											&g_set.img_focus.colorkey_green,
											&g_set.img_focus.colorkey_blue);
		}
		// b̃GtFNgԍ
		else if(!strcmp(ss,"<effect_arrow_talk>")){
			flag = 3;
		}
		else if(!strcmp(ss,"</effect_arrow_talk>")){
			flag = 0;
		}
		else if(flag == 3){
			sscanf(ss,"%d", &g_set.effect_arrow_talk);
		}
		// j[ij̃GtFNgԍ
		else if(!strcmp(ss,"<effect_arrow_menu1>")){
			flag = 4;
		}
		else if(!strcmp(ss,"</effect_arrow_menu1>")){
			flag = 0;
		}
		else if(flag == 4){
			sscanf(ss,"%d", &g_set.effect_arrow_menu1);
		}
		// j[ij̃GtFNgԍ
		else if(!strcmp(ss,"<effect_arrow_menu2>")){
			flag = 5;
		}
		else if(!strcmp(ss,"</effect_arrow_menu2>")){
			flag = 0;
		}
		else if(flag == 5){
			sscanf(ss,"%d", &g_set.effect_arrow_menu2);
		}
		// f̍ŨGtFNgԍ
		else if(!strcmp(ss,"<effect_bare>")){
			flag = 6;
		}
		else if(!strcmp(ss,"</effect_bare>")){
			flag = 0;
		}
		else if(flag == 6){
			sscanf(ss,"%d", &g_set.effect_bare);
		}
		// f̍Ǔʉԍ
		else if(!strcmp(ss,"<wave_bare>")){
			flag = 7;
		}
		else if(!strcmp(ss,"</wave_bare>")){
			flag = 0;
		}
		else if(flag == 7){
			sscanf(ss,"%d", &g_set.wave_bare);
		}
		// 퓬Ǐʉ
		else if(!strcmp(ss,"<wave_battle>")){
			flag = 8;
		}
		else if(!strcmp(ss,"</wave_battle>")){
			flag = 0;
		}
		else if(flag == 8){
			sscanf(ss,"%d %d %d", &g_set.flag_wave_battle, &g_set.wave_get, &g_set.wave_level_up);
		}
		// ł̌ʉԍ
		else if(!strcmp(ss,"<wave_poison>")){
			flag = 9;
		}
		else if(!strcmp(ss,"</wave_poison>")){
			flag = 0;
		}
		else if(flag == 9){
			sscanf(ss,"%d", &g_set.wave_poison);
		}
		// ̌ʉԍ
		else if(!strcmp(ss,"<wave_equip_set>")){
			flag = 10;
		}
		else if(!strcmp(ss,"</wave_equip_set>")){
			flag = 0;
		}
		else if(flag == 10){
			sscanf(ss,"%d", &g_set.wave_equip_set);
		}
		// ̌ʉԍ
		else if(!strcmp(ss,"<wave_equip_remove>")){
			flag = 11;
		}
		else if(!strcmp(ss,"</wave_equip_remove>")){
			flag = 0;
		}
		else if(flag == 11){
			sscanf(ss,"%d", &g_set.wave_equip_remove);
		}
		// xAbvBGMԍ
		else if(!strcmp(ss,"<midi_level_up>")){
			flag = 12;
		}
		else if(!strcmp(ss,"</midi_level_up>")){
			flag = 0;
		}
		else if(flag == 12){
			sscanf(ss, "%d", &g_set.midi_level_up);
		}
		// Q[I[o[BGMԍ
		else if(!strcmp(ss,"<midi_gameover>")){
			flag = 13;
		}
		else if(!strcmp(ss,"</midi_gameover>")){
			flag = 0;
		}
		else if(flag == 13){
			sscanf(ss, "%d", &g_set.midi_gameover);
		}
		// ʉݒP
		else if(!strcmp(ss,"<denomi_name>")){
			flag = 14;
		}
		else if(!strcmp(ss,"</denomi_name>")){
			flag = 0;
		}
		else if(flag == 14){
			strncpy(g_set.denomi_name, ss, sizeof(g_set.denomi_name));
		}
		// ̑
		else if(!strcmp(ss,"<line_thick>")){
			flag = 15;
		}
		else if(!strcmp(ss,"</line_thick>")){
			flag = 0;
		}
		else if(flag == 15){
			sscanf(ss,"%d", &g_set.line_thick);
		}
		// 퓬j[PFhԂ̔itrue or falsej
		else if(!strcmp(ss,"<flag_battle_alpha>")){
			flag = 16;
		}
		else if(!strcmp(ss,"</flag_battle_alpha>")){
			flag = 0;
		}
		else if(flag == 16){
			sscanf(ss,"%d", &g_set.flag_battle_alpha);
		}
		// Cxg̔wi摜ɂꍇ́Atrue, PFhԂ̏ꍇ́Afalse
		else if(!strcmp(ss,"<flag_back_bmp>")){
			flag = 17;
		}
		else if(!strcmp(ss,"</flag_back_bmp>")){
			flag = 0;
		}
		else if(flag == 17){
			sscanf(ss,"%d", &g_set.flag_back_bmp);
		}
		// j[ڑI̓x
		else if(!strcmp(ss,"<alpha_select>")){
			flag = 18;
		}
		else if(!strcmp(ss,"</alpha_select>")){
			flag = 0;
		}
		else if(flag == 18){
			sscanf(ss,"%d", &g_set.alpha_select);
		}
		// Cxg̘gF
		else if(!strcmp(ss,"<rgb_line>")){
			flag = 19;
		}
		else if(!strcmp(ss,"</rgb_line>")){
			flag = 0;
		}
		else if(flag == 19){
			sscanf(ss,"%d %d %d",	&g_set.rgb_line.red,
									&g_set.rgb_line.green,
									&g_set.rgb_line.blue);
		}
		// Cxg̔wiF
		else if(!strcmp(ss,"<rgb_back>")){
			flag = 20;
		}
		else if(!strcmp(ss,"</rgb_back>")){
			flag = 0;
		}
		else if(flag == 20){
			sscanf(ss,"%d %d %d",	&g_set.rgb_back.red,
									&g_set.rgb_back.green,
									&g_set.rgb_back.blue);
		}
		// 퓬j[㉺̔wiF
		else if(!strcmp(ss,"<rgb_battle_item>")){
			flag = 21;
		}
		else if(!strcmp(ss,"</rgb_battle_item>")){
			flag = 0;
		}
		else if(flag == 21){
			sscanf(ss,"%d %d %d",	&g_set.rgb_battle_item.red,
									&g_set.rgb_battle_item.green,
									&g_set.rgb_battle_item.blue);
		}
		// 퓬j[㉺̔wiF̓x
		else if(!strcmp(ss,"<alpha_battle_item>")){
			flag = 22;
		}
		else if(!strcmp(ss,"</alpha_battle_item>")){
			flag = 0;
		}
		else if(flag == 22){
			sscanf(ss,"%d", &g_set.alpha_battle_item);
		}
		// b̔wiF
		else if(!strcmp(ss,"<rgb_back_talk>")){
			flag = 23;
		}
		else if(!strcmp(ss,"</rgb_back_talk>")){
			flag = 0;
		}
		else if(flag == 23){
			sscanf(ss,"%d %d %d",	&g_set.rgb_back_talk.red,
									&g_set.rgb_back_talk.green,
									&g_set.rgb_back_talk.blue);
		}
		// b̃tF[h̍ől
		else if(!strcmp(ss,"<fade_max_talk>")){
			flag = 24;
		}
		else if(!strcmp(ss,"</fade_max_talk>")){
			flag = 0;
		}
		else if(flag == 24){
			sscanf(ss,"%d", &g_set.fade_max_talk);
		}
		// b̊摜\i0:ȂA1:A2:A3:[]]j
		else if(!strcmp(ss,"<flag_talk_face>")){
			flag = 25;
		}
		else if(!strcmp(ss,"</flag_talk_face>")){
			flag = 0;
		}
		else if(flag == 25){
			sscanf(ss,"%d", &g_set.flag_talk_face);
		}
		// bgYW
		else if(!strcmp(ss,"<talk_y>")){
			flag = 26;
		}
		else if(!strcmp(ss,"</talk_y>")){
			flag = 0;
		}
		else if(flag == 26){
			sscanf(ss,"%d", &g_set.talk_y);
		}
		// łɂ_[W󂯂
		else if(!strcmp(ss,"<poison_interval>")){
			flag = 27;
		}
		else if(!strcmp(ss,"</poison_interval>")){
			flag = 0;
		}
		else if(flag == 27){
			sscanf(ss,"%d", &g_set.poison_interval);
		}
		// PC ̕s̊炩
		else if(!strcmp(ss,"<move_interval_pc>")){
			flag = 28;
		}
		else if(!strcmp(ss,"</move_interval_pc>")){
			flag = 0;
		}
		else if(flag == 28){
			sscanf(ss,"%d", &g_set.move_interval_pc);
		}
		// NPC ̕s̊炩
		else if(!strcmp(ss,"<move_interval_npc>")){
			flag = 29;
		}
		else if(!strcmp(ss,"</move_interval_npc>")){
			flag = 0;
		}
		else if(flag == 29){
			sscanf(ss,"%d", &g_set.move_interval_npc);
		}
		// r[̃XN[Ȃ̈
		if(!strcmp(ss,"<no_scroll_area>")){
			flag = 30;
		}
		else if(!strcmp(ss,"</no_scroll_area>")){
			flag = 0;
		}
		else if(flag == 30){
			sscanf(ss,"%d %d", &g_set.no_scroll_area.x, &g_set.no_scroll_area.y);
		}
		// NPC ̒iJEg̍ől
		else if(!strcmp(ss,"<straight_max>")){
			flag = 31;
		}
		else if(!strcmp(ss,"</straight_max>")){
			flag = 0;
		}
		else if(flag == 31){
			sscanf(ss,"%d", &g_set.straight_max);
		}
		// Ŝ̕`摬x
		else if(!strcmp(ss,"<game_speed>")){
			flag = 32;
		}
		else if(!strcmp(ss,"</game_speed>")){
			flag = 0;
		}
		else if(flag == 32){
			sscanf(ss,"%d", &g_set.game_speed);
		}
		// tF[hx
		else if(!strcmp(ss,"<fade_speed>")){
			flag = 33;
		}
		else if(!strcmp(ss,"</fade_speed>")){
			flag = 0;
		}
		else if(flag == 33){
			sscanf(ss,"%d", &g_set.fade_speed);
		}
		// 퓬ԑx
		else if(!strcmp(ss,"<turn_speed>")){
			flag = 34;
		}
		else if(!strcmp(ss,"</turn_speed>")){
			flag = 0;
		}
		else if(flag == 34){
			sscanf(ss,"%d", &g_set.turn_speed);
		}
		// G̍Ux
		else if(!strcmp(ss,"<enemy_attack_speed>")){
			flag = 35;
		}
		else if(!strcmp(ss,"</enemy_attack_speed>")){
			flag = 0;
		}
		else if(flag == 35){
			sscanf(ss,"%d", &g_set.e_attack_speed);
		}
		// _[Wx
		else if(!strcmp(ss,"<damage_speed>")){
			flag = 36;
		}
		else if(!strcmp(ss,"</damage_speed>")){
			flag = 0;
		}
		else if(flag == 36){
			sscanf(ss,"%d", &g_set.damage_speed);
		}
		// G̃_[Wx
		else if(!strcmp(ss,"<enemy_damage_speed>")){
			flag = 37;
		}
		else if(!strcmp(ss,"</enemy_damage_speed>")){
			flag = 0;
		}
		else if(flag == 37){
			sscanf(ss,"%d", &g_set.e_damage_speed);
		}
		// tH[JX_őx
		else if(!strcmp(ss,"<focus_speed>")){
			flag = 38;
		}
		else if(!strcmp(ss,"</focus_speed>")){
			flag = 0;
		}
		else if(flag == 38){
			sscanf(ss,"%d", &g_set.focus_speed);
		}
		// \x
		else if(!strcmp(ss,"<letter_speed>")){
			flag = 39;
		}
		else if(!strcmp(ss,"</letter_speed>")){
			flag = 0;
		}
		else if(flag == 39){
			sscanf(ss,"%d", &g_set.letter_speed);
		}
		// tHg
		else if(!strcmp(ss,"<font_name>")){
			flag = 40;
		}
		else if(!strcmp(ss,"</font_name>")){
			flag = 0;
		}
		else if(flag == 40){
			strncpy(g_set.font_name, ss, 32);
		}
		// tHg̑
		else if(!strcmp(ss,"<font_weight>")){
			flag = 41;
		}
		else if(!strcmp(ss,"</font_weight>")){
			flag = 0;
		}
		else if(flag == 41){
			sscanf(ss,"%d", &g_set.font_weight);
		}
		// Fi0:ʏ, 1:I, 2:I2, 3:gps,
		//         4:Igps, 5:, 6:, 7:Ή, 8:Cj
		else if(!strcmp(ss,"<font_color>")){
			flag = 42;
			color_ct = 0;
		}
		else if(!strcmp(ss,"</font_color>")){
			flag = 0;
		}
		else if(flag == 42){
			if(color_ct < 9){
				sscanf(ss,"%d %d %d",	&g_set.font_color[color_ct].red,
										&g_set.font_color[color_ct].green,
										&g_set.font_color[color_ct].blue);
				color_ct ++;
			}
		}
		// Cxg̑傫
		else if(!strcmp(ss,"<event_font_size>")){
			flag = 43;
		}
		else if(!strcmp(ss,"</event_font_size>")){
			flag = 0;
		}
		else if(flag == 43){
			sscanf(ss,"%d", &g_set.event_font_size);
		}
		// b̑傫
		else if(!strcmp(ss,"<talk_font_size>")){
			flag = 44;
		}
		else if(!strcmp(ss,"</talk_font_size>")){
			flag = 0;
		}
		else if(flag == 44){
			sscanf(ss,"%d", &g_set.talk_font_size);
		}
		// ő\͒l
		else if(!strcmp(ss,"<ability_max>")){
			flag = 45;
		}
		else if(!strcmp(ss,"</ability_max>")){
			flag = 0;
		}
		else if(flag == 45){
			sscanf(ss,"%d", &g_set.ability_max);
		}
		// eACeLłő吔
		else if(!strcmp(ss,"<item_own_num>")){
			flag = 46;
		}
		else if(!strcmp(ss,"</item_own_num>")){
			flag = 0;
		}
		else if(flag == 46){
			sscanf(ss,"%d", &g_set.item_own_num);
		}
		// XŃACe𔄂Ƃ̔pi̊|
		else if(!strcmp(ss,"<item_sell_rate>")){
			flag = 47;
		}
		else if(!strcmp(ss,"</item_sell_rate>")){
			flag = 0;
		}
		else if(flag == 47){
			sscanf(ss,"%f", &g_set.item_sell_rate);
		}
		// XŔƂɕ\ACe̍ő吔
		else if(!strcmp(ss,"<buy_disp_num>")){
			flag = 48;
		}
		else if(!strcmp(ss,"</buy_disp_num>")){
			flag = 0;
		}
		else if(flag == 48){
			sscanf(ss,"%d", &g_set.buy_disp_num);
		}
		// XŔƂɕ\ACe̍ő吔
		else if(!strcmp(ss,"<sell_disp_num>")){
			flag = 49;
		}
		else if(!strcmp(ss,"</sell_disp_num>")){
			flag = 0;
		}
		else if(flag == 49){
			sscanf(ss,"%d", &g_set.sell_disp_num);
		}
		// j[ڂ̍ő\ij
		else if(!strcmp(ss,"<menu_disp_num1>")){
			flag = 50;
		}
		else if(!strcmp(ss,"</menu_disp_num1>")){
			flag = 0;
		}
		else if(flag == 50){
			sscanf(ss,"%d", &g_set.menu_disp_num1);
		}
		// j[ڂ̍ő\i@Aj
		else if(!strcmp(ss,"<menu_disp_num2>")){
			flag = 51;
		}
		else if(!strcmp(ss,"</menu_disp_num2>")){
			flag = 0;
		}
		else if(flag == 51){
			sscanf(ss,"%d", &g_set.menu_disp_num2);
		}
		// 퓬V[̖@ACe̍ő\
		else if(!strcmp(ss,"<battle_disp_num>")){
			flag = 52;
		}
		else if(!strcmp(ss,"</battle_disp_num>")){
			flag = 0;
		}
		else if(flag == 52){
			sscanf(ss,"%d", &g_set.battle_disp_num);
		}
		// Z[uf[^̍ő\
		else if(!strcmp(ss,"<save_disp_num>")){
			flag = 53;
		}
		else if(!strcmp(ss,"</save_disp_num>")){
			flag = 0;
		}
		else if(flag == 53){
			sscanf(ss,"%d", &g_set.save_disp_num);
		}
		// 퓬V[̖@ACȅ㉺̗]
		else if(!strcmp(ss,"<battle_item_y>")){
			flag = 54;
		}
		else if(!strcmp(ss,"</battle_item_y>")){
			flag = 0;
		}
		else if(flag == 54){
			sscanf(ss,"%d", &g_set.battle_item_y);
		}
		// 퓬V[̉bJn̑҂
		else if(!strcmp(ss,"<battle_wait1>")){
			flag = 55;
		}
		else if(!strcmp(ss,"</battle_wait1>")){
			flag = 0;
		}
		else if(flag == 55){
			sscanf(ss,"%d", &g_set.battle_wait1);
		}
		// 퓬V[̖@ACegp̑҂
		else if(!strcmp(ss,"<battle_wait2>")){
			flag = 56;
		}
		else if(!strcmp(ss,"</battle_wait2>")){
			flag = 0;
		}
		else if(flag == 56){
			sscanf(ss,"%d", &g_set.battle_wait2);
		}
		// Z[uf[^̍ő吔
		else if(!strcmp(ss,"<save_max>")){
			flag = 57;
		}
		else if(!strcmp(ss,"</save_max>")){
			flag = 0;
		}
		else if(flag == 57){
			sscanf(ss,"%d", &g_save_max);
		}
		// Cxg̃j[̕iXE퓬j
		else if(!strcmp(ss,"<menu_width1>")){
			flag = 58;
		}
		else if(!strcmp(ss,"</menu_width1>")){
			flag = 0;
		}
		else if(flag == 58){
			sscanf(ss,"%d", &g_set.menu_width1);
		}
		// Cxg̃j[̕ixAbvAj[j
		else if(!strcmp(ss,"<menu_width2>")){
			flag = 59;
		}
		else if(!strcmp(ss,"</menu_width2>")){
			flag = 0;
		}
		else if(flag == 59){
			sscanf(ss,"%d", &g_set.menu_width2);
		}
		// Cxg̃j[̕ib flag_back_bmp  true ̏ꍇj
		if(!strcmp(ss,"<menu_width3>")){
			flag = 60;
		}
		else if(!strcmp(ss,"</menu_width3>")){
			flag = 0;
		}
		else if(flag == 60){
			sscanf(ss,"%d", &g_set.menu_width3);
		}
		// j[ڂ̍
		else if(!strcmp(ss,"<item_height>")){
			flag = 61;
		}
		else if(!strcmp(ss,"</item_height>")){
			flag = 0;
		}
		else if(flag == 61){
			sscanf(ss,"%d", &g_set.item_height);
		}
		// tF[h AEg JEg̑i퓬̉, 1 or 2j
		else if(!strcmp(ss,"<fade_increment_monster>")){
			flag = 62;
		}
		else if(!strcmp(ss,"</fade_increment_monster>")){
			flag = 0;
		}
		else if(flag == 62){
			sscanf(ss,"%d", &g_set.fade_inc_monster);
		}
		// tF[h JEg̑ib, 1 or 2j
		else if(!strcmp(ss,"<fade_increment_talk>")){
			flag = 63;
		}
		else if(!strcmp(ss,"</fade_increment_talk>")){
			flag = 0;
		}
		else if(flag == 63){
			sscanf(ss,"%d", &g_set.fade_inc_talk);
		}
		// BGM ƌʉ̉ʁi-96 ` 0j
		else if(!strcmp(ss,"<vol_all>")){
			flag = 64;
		}
		else if(!strcmp(ss,"</vol_all>")){
			flag = 0;
		}
		else if(flag == 64){
			sscanf(ss,"%d", &g_set.vol_all);
		}
		// BGM ̉ʁi-96 ` 0j
		else if(!strcmp(ss,"<vol_bgm>")){
			flag = 65;
		}
		else if(!strcmp(ss,"</vol_bgm>")){
			flag = 0;
		}
		else if(flag == 65){
			sscanf(ss,"%d", &g_set.vol_bgm);
		}
		// ʉ̉ʁi-96 ` 0j
		else if(!strcmp(ss,"<vol_sound>")){
			flag = 66;
		}
		else if(!strcmp(ss,"</vol_sound>")){
			flag = 0;
		}
		else if(flag == 66){
			sscanf(ss,"%d", &g_set.vol_sound);
		}
		// AL[Ԏ擾Ԋu
		else if(!strcmp(ss,"<key_interval>")){
			flag = 67;
		}
		else if(!strcmp(ss,"</key_interval>")){
			flag = 0;
		}
		else if(flag == 67){
			sscanf(ss,"%d", &g_set.key_interval);
		}
		// b̗]
		else if(!strcmp(ss,"<talk_margin>")){
			flag = 68;
		}
		else if(!strcmp(ss,"</talk_margin>")){
			flag = 0;
		}
		else if(flag == 68){
			sscanf(ss,"%d", &g_set.talk_margin);
		}
		// ̍W
		else if(!strcmp(ss,"<pos_menu_item>")){
			flag = 69;
		}
		else if(!strcmp(ss,"</pos_menu_item>")){
			flag = 0;
		}
		else if(flag == 69){
			sscanf(ss,"%d %d", &g_set.pos_menu_item.x,  &g_set.pos_menu_item.y);
		}
		// 퓬̃NeBJqbgij
		else if(!strcmp(ss,"<critical_rate>")){
			flag = 70;
		}
		else if(!strcmp(ss,"</critical_rate>")){
			flag = 0;
		}
		else if(flag == 70){
			sscanf(ss,"%d", &g_set.critical_rate);
		}
		// ʏ_[WUꕝ
		else if(!strcmp(ss,"<ampl_damage>")){
			flag = 71;
		}
		else if(!strcmp(ss,"</ampl_damage>")){
			flag = 0;
		}
		else if(flag == 71){
			sscanf(ss,"%d", &g_set.ampl_damage);
		}
		// ʏ_[WUꕝiNeBJ qbg̏ꍇj
		else if(!strcmp(ss,"<ampl_damage_crt>")){
			flag = 72;
		}
		else if(!strcmp(ss,"</ampl_damage_crt>")){
			flag = 0;
		}
		else if(flag == 72){
			sscanf(ss,"%d", &g_set.ampl_damage_crt);
		}
		// GUړ
		else if(!strcmp(ss,"<dist_enemy_attack>")){
			flag = 73;
		}
		else if(!strcmp(ss,"</dist_enemy_attack>")){
			flag = 0;
		}
		else if(flag == 73){
			sscanf(ss,"%d", &g_set.dist_enemy_attack);
		}
		// NeBJ qbǧʉGtFNgԍ
		else if(!strcmp(ss,"<effect_wave_crt>")){
			flag = 74;
		}
		else if(!strcmp(ss,"</effect_wave_crt>")){
			flag = 0;
		}
		else if(flag == 74){
			sscanf(ss,"%d", &g_set.effect_wave_crt);
		}
		// NeBJ qbǧʉ̉ʁi-96 ` 0j
		else if(!strcmp(ss,"<vol_sound_crt>")){
			flag = 75;
		}
		else if(!strcmp(ss,"</vol_sound_crt>")){
			flag = 0;
		}
		else if(flag == 75){
			sscanf(ss,"%d", &g_set.vol_sound_crt);
		}
	}
	fclose(file1);
	
	return true;
}// Load_Setting

// f[^ǂݍݏݒ̓ǂݍ
bool Load_Prepare(char *filename)
{
	int  flag = 0;
	char ss[READ_LEN_MAX1];
	
	FILE *file1 = fopen(filename, "r");
	
	if(!file1){
		return false;
	}
	
	while(!feof(file1)){
		ZeroMemory(ss, sizeof(ss));
		fgets(ss,sizeof(ss),file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// t@CtH_̖O
		if(!strcmp(ss,"<folder_name_data>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</folder_name_data>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%s", g_dir.strData);
		}
		// 摜t@CtH_̖O
		else if(!strcmp(ss,"<folder_name_image>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</folder_name_image>")){
			flag = 0;
		}
		else if(flag == 2){
			sscanf(ss,"%s", g_dir.strImage);
		}
		// yt@CtH_̖O
		else if(!strcmp(ss,"<folder_name_audio>")){
			flag = 3;
		}
		else if(!strcmp(ss,"</folder_name_audio>")){
			flag = 0;
		}
		else if(flag == 3){
			sscanf(ss,"%s", g_dir.strAudio);
		}
		// ǂݍݒ摜
		else if(!strcmp(ss,"<load_image>")){
			flag = 4;
		}
		else if(!strcmp(ss,"</load_image>")){
			flag = 0;
		}
		else if(flag == 4){
			sscanf(ss,"%s", g_dir.strLoadImage);
		}
	}
	fclose(file1);
	
	return true;
}// Load_Prepare

void Init_EffectData()
{
	int i;
	
	if(g_ine.inf){
		for(i=0;i<g_ine.num;i++){
			SAFE_FREE(g_ine.inf[i].inf4.pos);
		}
		SAFE_FREE(g_ine.inf);
	}
	g_ine.num = 0;
}// Init_EffectData

void Init_MapAnimData()
{
	int i;
	
	if(g_inma.inf){
		for(i=0;i<g_inma.inf_num;i++){
			SAFE_FREE(g_inma.inf[i].pos);
		}
		SAFE_FREE(g_inma.inf);
	}
	g_inma.inf_num = 0;
}// Init_MapAnimData

void Init_PcData()
{
	SAFE_FREE(g_pc.idxMagic);
	SAFE_FREE(g_pc.item);
	ZeroMemory(&g_pc, sizeof(g_pc));
	g_pc.interval_ct = g_set.move_interval_pc;
	g_pc.alpha_ct = 32;
}// Init_PcData

void Init_SceneData()
{
	int i,j;
	
	if(g_sn.evt_cmd){
		for(i=0;i<g_sn.evt_cmd_num;i++){
			for(j=0;j<g_sn.evt_cmd[i].num;j++){
				SAFE_FREE(g_sn.evt_cmd[i].str[j]);
			}
			SAFE_FREE(g_sn.evt_cmd[i].str);
		}
		SAFE_FREE(g_sn.evt_cmd);
	}
	SAFE_FREE(g_sn.npc_index);
	SAFE_FREE(g_sn.tre_index);
	SAFE_FREE(g_sn.battle);
	SAFE_FREE(g_sn.scene_change);
	SAFE_FREE(g_sn.event_pos);
	ZeroMemory(&g_sn, sizeof(g_sn));
}// Init_SceneData

void Term_RpgFile()
{
	int i;
	
	if(g_n.inf){
		SAFE_FREE(g_n.inf);
	}
	if(g_talk.str){
		for(i=0;i<g_talk.num;i++){
			SAFE_FREE(g_talk.str[i]);
		}
		SAFE_FREE(g_talk.str);
	}
	if(g_shop.inf){
		for(i=0;i<g_shop.num;i++){
			SAFE_FREE(g_shop.inf[i].item_index);
		}
		SAFE_FREE(g_shop.inf);
	}
	if(g_enemy.inf){
		for(i=0;i<g_enemy.num;i++){
			SAFE_FREE(g_enemy.inf[i].inf);
		}
		SAFE_FREE(g_enemy.inf);
	}
	if(g_npc.inf){
		SAFE_FREE(g_npc.inf);
	}
	if(g_tre.inf){
		SAFE_FREE(g_tre.inf);
	}
	SAFE_FREE(g_item.inf);
	SAFE_FREE(g_level.exp);
	SAFE_FREE(g_lvlabl.la);
	SAFE_FREE(g_magic.inf);
	SAFE_FREE(g_inb.inf);
	SAFE_FREE(g_ins.inf);
	SAFE_FREE(g_inf.inf);
	SAFE_FREE(g_monster.inf);
	g_talk.num = 0;
	g_shop.num = 0;
	g_enemy.num = 0;
	g_npc.num = 0;
	g_tre.num = 0;
	g_item.num = 0;
	g_level.exp_num = 0;
	g_lvlabl.num = 0;
	g_magic.num = 0;
	g_inb.num = 0;
	g_ins.num = 0;
	g_inf.num = 0;
	g_n.num = 0;
	g_monster.num = 0;
	Init_PcData();
	Init_EffectData();
	Init_MapAnimData();
	Init_SceneData();
}// Term_RpgFile
