#include <windows.h>
#include <stdio.h>
#include <mbstring.h>
#include "RPGDataCnv.h"
#include "LoadTxt.h"

void Fwrite_Tag(FILE *file2, char tag[][TAG_LEN], int idx, int size);
bool Save_Prepare_Bin(char *filename);
bool Save_StartGame_Bin(char *filename);
bool Save_BGM_Bin(char *filename);
bool Save_Sound_Bin(char *filename);
bool Save_Title_Bin(char *filename);
bool Save_Narration_Bin(char *filename);
bool Save_Talk_Bin(char *filename);
bool Save_Item_Bin(char *filename);
bool Save_Shop_Bin(char *filename);
bool Save_LevelList_Bin(char *filename);
bool Save_LevelAbility_Bin(char *filename);
bool Save_Monster_Bin(char *filename);
bool Save_Enemy_Bin(char *filename);
bool Save_Magic_Bin(char *filename);
bool Save_BackImage_Bin(char *filename);
bool Save_SelImage_Bin(char *filename);
bool Save_FaceImage_Bin(char *filename);
bool Save_Effect_Bin(char *filename);
bool Save_MapAnim_Bin(char *filename);
bool Save_Treasure_Bin(char *filename);
bool Save_PC_Bin(char *filename);
bool Save_NPC_Bin(char *filename);
bool Save_Scene_Bin(char *filename);
bool Save_Setting_Bin(char *filename);

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	if(__argc > 1){
		int i,j;
		for(i=1; i<__argc; i++){
			char filenameSave[MAX_PATH];
			char filenameCmp[MAX_PATH];
			char strExt[MAX_PATH];
			strncpy(filenameSave, __argv[i], sizeof(filenameSave));
			char *p = strrchr(filenameSave, '.');
			strcpy(p, ".dat");
			char *p2 = strrchr(__argv[i], '\\');
			strncpy(filenameCmp, p2 + 1, sizeof(filenameCmp));
			char *p3 = strrchr(filenameCmp, '.');
			strcpy(strExt, p3 + 1);
			if(!strcmp(filenameCmp, "prepare.txt")){
				if(Load_Prepare(__argv[i])){
					Save_Prepare_Bin(filenameSave);
				}
			}
			else if(!strcmp(filenameCmp, "start_game.txt")){
				if(Load_StartGame(__argv[i])){
					Save_StartGame_Bin(filenameSave);
				}
			}
			else if(!strcmp(filenameCmp, "midi_list.txt")){
				if(Load_MidiList(__argv[i])){
					Save_BGM_Bin(filenameSave);
				}
			}
			else if(!strcmp(filenameCmp, "wave_list.txt")){
				if(Load_WaveList(__argv[i])){
					Save_Sound_Bin(filenameSave);
				}
			}
			else if(!strcmp(filenameCmp, "title.txt")){
				if(Load_Title(__argv[i])){
					Save_Title_Bin(filenameSave);
				}
			}
			else if(!strcmp(filenameCmp, "narration_list.txt")){
				if(Load_NarrationList(__argv[i])){
					Save_Narration_Bin(filenameSave);
				}
				if(g_n.inf){
					SAFE_FREE(g_n.inf);
				}
			}
			else if(!strcmp(filenameCmp, "talk_list.txt")){
				if(Load_TalkList(__argv[i])){
					Save_Talk_Bin(filenameSave);
				}
				if(g_talk.str){
					for(j=0; j<g_talk.num; j++){
						SAFE_FREE(g_talk.str[j]);
					}
					SAFE_FREE(g_talk.str);
				}
				g_talk.num = 0;
			}
			else if(!strcmp(filenameCmp, "item_list.txt")){
				if(Load_ItemList(__argv[i])){
					Save_Item_Bin(filenameSave);
				}
				SAFE_FREE(g_item.inf);
				g_item.num = 0;
			}
			else if(!strcmp(filenameCmp, "shop_list.txt")){
				if(Load_ShopList(__argv[i])){
					Save_Shop_Bin(filenameSave);
				}
				if(g_shop.inf){
					for(j=0; j<g_shop.num; j++){
						SAFE_FREE(g_shop.inf[j].item_index);
					}
					SAFE_FREE(g_shop.inf);
				}
				g_shop.num = 0;
			}
			else if(!strcmp(filenameCmp, "level_list.txt")){
				if(Load_LevelList(__argv[i])){
					Save_LevelList_Bin(filenameSave);
				}
				SAFE_FREE(g_level.exp);
				g_level.exp_num = 0;
			}
			else if(!strcmp(filenameCmp, "level_ability_list.txt")){
				if(Load_LevelAbilityList(__argv[i])){
					Save_LevelAbility_Bin(filenameSave);
				}
				SAFE_FREE(g_lvlabl.la);
				g_lvlabl.num = 0;
			}
			else if(!strcmp(filenameCmp, "monster_list.txt")){
				if(Load_MonsterList(__argv[i])){
					Save_Monster_Bin(filenameSave);
				}
				SAFE_FREE(g_monster.inf);
				g_monster.num = 0;
			}
			else if(!strcmp(filenameCmp, "enemy_list.txt")){
				if(Load_EnemyList(__argv[i])){
					Save_Enemy_Bin(filenameSave);
				}
				if(g_enemy.inf){
					for(j=0; j<g_enemy.num; j++){
						SAFE_FREE(g_enemy.inf[j].inf);
					}
					SAFE_FREE(g_enemy.inf);
				}
				g_enemy.num = 0;
			}
			else if(!strcmp(filenameCmp, "magic_list.txt")){
				if(Load_MagicList(__argv[i])){
					Save_Magic_Bin(filenameSave);
				}
				SAFE_FREE(g_magic.inf);
				g_magic.num = 0;
			}
			else if(!strcmp(filenameCmp, "image_back.txt")){
				if(Load_BackImageFileName(__argv[i])){
					Save_BackImage_Bin(filenameSave);
				}
				SAFE_FREE(g_inb.inf);
				g_inb.num = 0;
			}
			else if(!strcmp(filenameCmp, "image_select.txt")){
				if(Load_SelImageFileName(__argv[i])){
					Save_SelImage_Bin(filenameSave);
				}
				SAFE_FREE(g_ins.inf);
				g_ins.num = 0;
			}
			else if(!strcmp(filenameCmp, "image_face.txt")){
				if(Load_FaceImageFileName(__argv[i])){
					Save_FaceImage_Bin(filenameSave);
				}
				SAFE_FREE(g_inf.inf);
				g_inf.num = 0;
			}
			else if(!strcmp(filenameCmp, "image_effect.txt")){
				if(Load_EffectFileName(__argv[i])){
					Save_Effect_Bin(filenameSave);
				}
				Init_EffectData();
			}
			else if(!strncmp(filenameCmp, "map_anim", 8) && !strcmp(strExt, "txt")){
				if(Load_MapAnimFileName(__argv[i])){
					Save_MapAnim_Bin(filenameSave);
				}
				Init_MapAnimData();
			}
			else if(!strcmp(filenameCmp, "treasure_list.txt")){
				if(Load_TreasureList(__argv[i])){
					Save_Treasure_Bin(filenameSave);
				}
				SAFE_FREE(g_tre.inf);
				g_tre.num = 0;
			}
			else if(!strcmp(filenameCmp, "pc.txt")){
				if(Load_PC(__argv[i])){
					Save_PC_Bin(filenameSave);
				}
				Init_PcData();
			}
			else if(!strcmp(filenameCmp, "npc_list.txt")){
				if(Load_NpcList(__argv[i])){
					Save_NPC_Bin(filenameSave);
				}
				SAFE_FREE(g_npc.inf);
			}
			else if(!strncmp(filenameCmp, "scene", 5) && !strcmp(strExt, "txt")){
				if(Load_SceneData(__argv[i])){
					Save_Scene_Bin(filenameSave);
				}
				Init_SceneData();
			}
			else if(!strcmp(filenameCmp, "setting.txt")){
				if(Load_Setting(__argv[i])){
					Save_Setting_Bin(filenameSave);
				}
			}
		}
		Term_RpgFile();
	}
	return 0;
}

// dat t@CɃ^Oۑ
void Fwrite_Tag(FILE *file2, char tag[][TAG_LEN], int idx, int size)
{
	int len = (strlen(tag[idx])+1);
	
	fwrite(&len,sizeof(int),1,file2);
	fwrite(tag[idx],sizeof(char),len,file2);
	fwrite(&size,sizeof(int),1,file2);
}// Fwrite_Tag

// f[^ prepare.dat ɕۑioCij
bool Save_Prepare_Bin(char *filename)
{
	FILE *file2;
	int  len;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_prepare) / sizeof(g_tag_prepare[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	len = strlen(g_dir.strData) + 1;
	Fwrite_Tag(file2, g_tag_prepare, 0, sizeof(int) + len);
	fwrite(&len, sizeof(int), 1, file2);
	fwrite(g_dir.strData, sizeof(char), len, file2);
	len = strlen(g_dir.strImage) + 1;
	Fwrite_Tag(file2, g_tag_prepare, 1, sizeof(int) + len);
	fwrite(&len, sizeof(int), 1, file2);
	fwrite(g_dir.strImage, sizeof(char), len, file2);
	len = strlen(g_dir.strAudio) + 1;
	Fwrite_Tag(file2, g_tag_prepare, 2, sizeof(int) + len);
	fwrite(&len, sizeof(int), 1, file2);
	fwrite(g_dir.strAudio, sizeof(char), len, file2);
	len = strlen(g_dir.strLoadImage) + 1;
	Fwrite_Tag(file2, g_tag_prepare, 3, sizeof(int) + len);
	fwrite(&len, sizeof(int), 1, file2);
	fwrite(g_dir.strLoadImage, sizeof(char), len, file2);
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_Prepare_Bin

// f[^ start_game.dat ɕۑioCij
bool Save_StartGame_Bin(char *filename)
{
	FILE *file2;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_start_game) / sizeof(g_tag_start_game[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_start_game, 0, sizeof(int));
	fwrite(&gIdxScene, sizeof(int), 1, file2);
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_StartGame_Bin

// f[^ midi_list.dat ɕۑ
bool Save_BGM_Bin(char *filename)
{
	FILE *file2;
	int  i;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_midi) / sizeof(g_tag_midi[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_midi, 0, sizeof(int));
	fwrite(&g_bgm.num, sizeof(int), 1, file2);
	int size = 0;
	for(i=0; i<g_bgm.num; i++){
		size += (sizeof(int) + strlen(g_bgm.name[i]) + 1);
	}
	Fwrite_Tag(file2, g_tag_midi, 1, size);
	for(i=0; i<g_bgm.num; i++){
		int len = strlen(g_bgm.name[i]) + 1;
		fwrite(&len, sizeof(int), 1, file2);
		fwrite(g_bgm.name[i], sizeof(char), len, file2);
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_BGM_Bin

// f[^ wave_list.dat ɕۑ
bool Save_Sound_Bin(char *filename)
{
	FILE *file2;
	int  i;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_wave) / sizeof(g_tag_wave[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_wave, 0, sizeof(int));
	fwrite(&g_snd.num, sizeof(int), 1, file2);
	int size = 0;
	for(i=0; i<g_snd.num; i++){
		size += (sizeof(int) + strlen(g_snd.name[i]) + 1);
	}
	Fwrite_Tag(file2, g_tag_wave, 1, size);
	for(i=0; i<g_snd.num; i++){
		int len = strlen(g_snd.name[i]) + 1;
		fwrite(&len, sizeof(int), 1, file2);
		fwrite(g_snd.name[i], sizeof(char), len, file2);
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_Sound_Bin

// ^Cgݒۑ
bool Save_Title_Bin(char *filename)
{
	FILE *file2;
	int  i;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_title) / sizeof(g_tag_title[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_title, 0, sizeof(int));
	fwrite(&g_t.idxMidi, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_title, 1, sizeof(POINT));
	fwrite(&g_t.ptSelect, sizeof(POINT), 1, file2);
	Fwrite_Tag(file2, g_tag_title, 2, sizeof(int));
	fwrite(&g_t.hgtSelect, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_title, 3, sizeof(int));
	fwrite(&g_t.sizeFont, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_title, 4, sizeof(COLOR) * 4);
	fwrite(g_t.colorFont, sizeof(COLOR), 4, file2);
	Fwrite_Tag(file2, g_tag_title, 5, sizeof(int));
	fwrite(&g_t.nSelect, sizeof(int), 1, file2);
	int size = 0;
	for(i=0; i<g_t.nSelect; i++){
		size += (sizeof(BOOL) + sizeof(int) * 2 + strlen(g_t.strSelect[i]) + 1);
	}
	Fwrite_Tag(file2, g_tag_title, 6, size);
	for(i=0; i<g_t.nSelect; i++){
		fwrite(&g_t.bFadeOutSelect[i], sizeof(BOOL), 1, file2);
		fwrite(&g_t.idxSelect[i], sizeof(int), 1, file2);
		int len = strlen(g_t.strSelect[i]) + 1;
		fwrite(&len, sizeof(int), 1, file2);
		fwrite(g_t.strSelect[i], sizeof(char), len, file2);
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_Title_Bin

// ^Cgݒۑ
bool Save_Narration_Bin(char *filename)
{
	FILE *file2;
	int  i,len;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_nar) / sizeof(g_tag_nar[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_nar, 0, sizeof(int));
	fwrite(&g_n.num, sizeof(int), 1, file2);
	int size;
	size = 0;
	for(i=0; i<g_n.num; i++){
		size += (sizeof(int) * 7 + sizeof(COLOR) + sizeof(RECT) + strlen(g_n.inf[i].nameImg) + 1);
	}
	if(g_n.inf){
		Fwrite_Tag(file2, g_tag_nar, 1, size);
		for(i=0; i<g_n.num; i++){
			fwrite(&g_n.inf[i].idxTalk, sizeof(int), 1, file2);
			fwrite(&g_n.inf[i].sizeFont, sizeof(int), 1, file2);
			fwrite(&g_n.inf[i].colorFont, sizeof(COLOR), 1, file2);
			fwrite(&g_n.inf[i].rcTalk, sizeof(RECT), 1, file2);
			fwrite(&g_n.inf[i].nLetterSpeed, sizeof(int), 1, file2);
			fwrite(&g_n.inf[i].nWaitTime1, sizeof(int), 1, file2);
			fwrite(&g_n.inf[i].nWaitTime2, sizeof(int), 1, file2);
			len = strlen(g_n.inf[i].nameImg) + 1;
			fwrite(&len, sizeof(int), 1, file2);
			fwrite(g_n.inf[i].nameImg, sizeof(char), len, file2);
			fwrite(&g_n.inf[i].idxMidi, sizeof(int), 1, file2);
		}
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_Narration_Bin

// f[^ talk_list.dat ɕۑioCij
bool Save_Talk_Bin(char *filename)
{
	FILE *file2;
	int  i,len;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_talk) / sizeof(g_tag_talk[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_talk, 0, sizeof(int));
	fwrite(&g_talk.num, sizeof(int), 1, file2);
	if(g_talk.str){
		int size = 0;
		for(i=0; i<g_talk.num; i++){
			size += (sizeof(int) + strlen(g_talk.str[i]) + 1);
		}
		Fwrite_Tag(file2, g_tag_talk, 1, size);
		for(i=0; i<g_talk.num; i++){
			// 񒆂 #  \n ɒu
			UCHAR	*pustr = (UCHAR*) g_talk.str[i];
			while(*pustr != '\0'){
				if(*pustr == '#'){
					*pustr = '\n';
				}
				pustr = _mbsinc(pustr);
			}
			// ۑ
			len = strlen(g_talk.str[i]) + 1;
			fwrite(&len, sizeof(int), 1, file2);
			fwrite(g_talk.str[i], sizeof(char), len, file2);
		}
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_Talk_Bin

// f[^ item_list.dat ɕۑ
bool Save_Item_Bin(char *filename)
{
	FILE *file2;
	int  i;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_item) / sizeof(g_tag_item[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_item, 0, sizeof(int));
	fwrite(&g_item.num, sizeof(int), 1, file2);
	if(g_item.inf){
		Fwrite_Tag(file2, g_tag_item, 1, sizeof(ITEM) * g_item.num);
		for(i=0; i<g_item.num; i++){
			// 񒆂 #  \n ɒu
			UCHAR	*pustr = (UCHAR*) g_item.inf[i].exp;
			while(*pustr != '\0'){
				if(*pustr == '#'){
					*pustr = '\n';
				}
				pustr = _mbsinc(pustr);
			}
		}
		fwrite(g_item.inf, sizeof(ITEM), g_item.num, file2);
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_Item_Bin

// f[^ shop_list.dat ɕۑ
bool Save_Shop_Bin(char *filename)
{
	FILE *file2;
	int  i,j,len;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_shop) / sizeof(g_tag_shop[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_shop, 0, sizeof(int));
	fwrite(&g_shop.num, sizeof(int), 1, file2);
	if(g_shop.inf){
		int size = 0;
		for(i=0; i<g_shop.num; i++){
			size += sizeof(int) * 8 + sizeof(int) * g_shop.inf[i].item_num;
			size += (strlen(g_shop.inf[i].filenameBgBuy) + 1);
			size += (strlen(g_shop.inf[i].filenameBgSell) + 1);
		}
		Fwrite_Tag(file2, g_tag_shop, 1, size);
		for(i=0; i<g_shop.num; i++){
			fwrite(&g_shop.inf[i].kind, sizeof(int), 1, file2);
			len = strlen(g_shop.inf[i].filenameBgBuy) + 1;
			fwrite(&len, sizeof(int), 1, file2);
			fwrite(g_shop.inf[i].filenameBgBuy, sizeof(char), len, file2);
			len = strlen(g_shop.inf[i].filenameBgSell) + 1;
			fwrite(&len, sizeof(int), 1, file2);
			fwrite(g_shop.inf[i].filenameBgSell, sizeof(char), len, file2);
			fwrite(&g_shop.inf[i].item_num, sizeof(int), 1, file2);
			if(g_shop.inf[i].item_index){
				for(j=0; j<g_shop.inf[i].item_num; j++){
					fwrite(&g_shop.inf[i].item_index[j], sizeof(int), 1, file2);
				}
			}
		}
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_Shop_Bin

// f[^ level_list.dat ɕۑ
bool Save_LevelList_Bin(char *filename)
{
	FILE *file2;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_level_list) / sizeof(g_tag_level_list[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_level_list, 0, sizeof(int));
	fwrite(&g_level.exp_num, sizeof(int), 1, file2);
	if(g_level.exp){
		Fwrite_Tag(file2, g_tag_level_list, 1, sizeof(LEVEL1) * g_level.exp_num);
		fwrite(g_level.exp, sizeof(LEVEL1), g_level.exp_num, file2);
	}
	Fwrite_Tag(file2, g_tag_level_list, 2, sizeof(LEVEL1));
	fwrite(&g_level.add, sizeof(LEVEL1), 1, file2);
	Fwrite_Tag(file2, g_tag_level_list, 3, sizeof(int));
	fwrite(&g_level.max, sizeof(int), 1, file2);
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_LevelList_Bin

// f[^ level_ability_list.dat ɕۑ
bool Save_LevelAbility_Bin(char *filename)
{
	FILE *file2;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_level_ability) / sizeof(g_tag_level_ability[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_level_ability, 0, sizeof(int));
	fwrite(&g_lvlabl.num, sizeof(int), 1, file2);
	if(g_lvlabl.la){
		Fwrite_Tag(file2, g_tag_level_ability, 1, sizeof(LEVELABILITY1) * g_lvlabl.num);
		fwrite(g_lvlabl.la, sizeof(LEVELABILITY1), g_lvlabl.num, file2);
	}
	int len = strlen(g_lvlabl.str) + 1;
	Fwrite_Tag(file2, g_tag_level_ability, 2, sizeof(int) + len);
	fwrite(&len, sizeof(int), 1, file2);
	fwrite(g_lvlabl.str, sizeof(char), len, file2);
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_LevelAbility_Bin

// f[^ monster_list.dat ɕۑ
bool Save_Monster_Bin(char *filename)
{
	FILE *file2;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_monster) / sizeof(g_tag_monster[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_monster, 0, sizeof(int));
	fwrite(&g_monster.num, sizeof(int), 1, file2);
	if(g_monster.inf){
		Fwrite_Tag(file2, g_tag_monster, 1, sizeof(MONSTER) * g_monster.num);
		fwrite(g_monster.inf, sizeof(MONSTER), g_monster.num, file2);
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_Monster_Bin

// f[^ enemy_list.dat ɕۑ
bool Save_Enemy_Bin(char *filename)
{
	FILE	*file2;
	int		i;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_enemy) / sizeof(g_tag_enemy[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_enemy, 0, sizeof(int));
	fwrite(&g_enemy.num, sizeof(int), 1, file2);
	if(g_enemy.inf){
		int size = 0;
		for(i=0; i<g_enemy.num; i++){
			size += sizeof(int);
			size += (sizeof(ENEMIES) * g_enemy.inf[i].num);
		}
		Fwrite_Tag(file2, g_tag_enemy, 1, size);
		for(i=0; i<g_enemy.num; i++){
			if(g_enemy.inf[i].inf){
				fwrite(&g_enemy.inf[i].num, sizeof(int), 1, file2);
				fwrite(g_enemy.inf[i].inf, sizeof(ENEMIES), g_enemy.inf[i].num, file2);
			}
		}
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_Enemy_Bin

// f[^ magic_list.dat ɕۑ
bool Save_Magic_Bin(char *filename)
{
	FILE	*file2;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_magic) / sizeof(g_tag_magic[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_magic, 0, sizeof(int));
	fwrite(&g_magic.num, sizeof(int), 1, file2);
	if(g_magic.inf){
		Fwrite_Tag(file2, g_tag_magic, 1, sizeof(MAGIC) * g_magic.num);
		fwrite(g_magic.inf, sizeof(MAGIC), g_magic.num, file2);
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_Magic_Bin

// f[^ image_back.dat ɕۑ
bool Save_BackImage_Bin(char *filename)
{
	FILE	*file2;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_image_back) / sizeof(g_tag_image_back[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_image_back, 0, sizeof(int));
	fwrite(&g_inb.num, sizeof(int), 1, file2);
	if(g_inb.inf){
		Fwrite_Tag(file2, g_tag_image_back, 1, sizeof(IMGINF) * g_inb.num);
		fwrite(g_inb.inf, sizeof(IMGINF), g_inb.num, file2);
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_BackImage_Bin

// f[^ image_select.dat ɕۑ
bool Save_SelImage_Bin(char *filename)
{
	FILE	*file2;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_image_sel) / sizeof(g_tag_image_sel[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_image_sel, 0, sizeof(int));
	fwrite(&g_ins.num, sizeof(int), 1, file2);
	if(g_ins.inf){
		Fwrite_Tag(file2, g_tag_image_sel, 1, sizeof(IMGINF) * g_ins.num);
		fwrite(g_ins.inf, sizeof(IMGINF), g_ins.num, file2);
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_SelImage_Bin

// f[^ image_face.dat ɕۑ
bool Save_FaceImage_Bin(char *filename)
{
	FILE	*file2;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_image_face) / sizeof(g_tag_image_face[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_image_face, 0, sizeof(int));
	fwrite(&g_inf.num, sizeof(int), 1, file2);
	if(g_inf.inf){
		Fwrite_Tag(file2, g_tag_image_face, 1, sizeof(IMGINF2) * g_inf.num);
		fwrite(g_inf.inf, sizeof(IMGINF2), g_inf.num, file2);
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_FaceImage_Bin

// f[^ image_effect.dat ɕۑ
bool Save_Effect_Bin(char *filename)
{
	FILE	*file2;
	int		i;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_image_effect) / sizeof(g_tag_image_effect[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_image_effect, 0, sizeof(int));
	fwrite(&g_ine.num, sizeof(int), 1, file2);
	if(g_ine.inf){
		int size = 0;
		for(i=0; i<g_ine.num; i++){
			size += sizeof(IMGINF3);
			size += (sizeof(int) + sizeof(POSIMG) * g_ine.inf[i].inf4.pos_num);
		}
		Fwrite_Tag(file2, g_tag_image_effect, 1, size);
		for(i=0; i<g_ine.num; i++){
			fwrite(&g_ine.inf[i].inf3, sizeof(IMGINF3), 1, file2);
			fwrite(&g_ine.inf[i].inf4.pos_num, sizeof(int), 1, file2);
			if(g_ine.inf[i].inf4.pos){
				fwrite(g_ine.inf[i].inf4.pos, sizeof(POSIMG), g_ine.inf[i].inf4.pos_num, file2);
			}
		}
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_Effect_Bin

// f[^ map_anim?.dat ɕۑ
bool Save_MapAnim_Bin(char *filename)
{
	FILE	*file2;
	int		i;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_map_anim) / sizeof(g_tag_map_anim[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	int len = strlen(g_inma.name) + 1;
	int size1 = len + sizeof(int) * 4;
	Fwrite_Tag(file2, g_tag_map_anim, 0, size1);
	fwrite(&len, sizeof(int), 1, file2);
	fwrite(g_inma.name, sizeof(char), len, file2);
	fwrite(&g_inma.width, sizeof(int), 1, file2);
	fwrite(&g_inma.height, sizeof(int), 1, file2);
	fwrite(&g_inma.speed, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_map_anim, 1, sizeof(int));
	fwrite(&g_inma.inf_num, sizeof(int), 1, file2);
	if(g_inma.inf){
		int size2 = 0;
		for(i=0; i<g_inma.inf_num; i++){
			size2 += (sizeof(int) + sizeof(POINT) * g_inma.inf[i].pos_num);
		}
		Fwrite_Tag(file2, g_tag_map_anim, 2, size2);
		for(i=0; i<g_inma.inf_num; i++){
			fwrite(&g_inma.inf[i].pos_num, sizeof(int), 1, file2);
			if(g_inma.inf[i].pos){
				fwrite(g_inma.inf[i].pos, sizeof(POINT), g_inma.inf[i].pos_num, file2);
			}
		}
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_MapAnim_Bin

// f[^ treasure_list.dat ɕۑ
bool Save_Treasure_Bin(char *filename)
{
	FILE	*file2;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_treasure) / sizeof(g_tag_treasure[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_treasure, 0, sizeof(int));
	fwrite(&g_tre.num, sizeof(int), 1, file2);
	if(g_tre.inf){
		int size = (sizeof(BOOL) * 4 + sizeof(POINT) + sizeof(int) * 3) * g_tre.num;
		Fwrite_Tag(file2, g_tag_treasure, 1, size);
		for(int i=0; i<g_tre.num; i++){
			fwrite(&g_tre.inf[i].flag_show, sizeof(BOOL), 1, file2);
			fwrite(&g_tre.inf[i].flag_once, sizeof(BOOL), 1, file2);
			fwrite(&g_tre.inf[i].flag_opened, sizeof(BOOL), 1, file2);
			fwrite(&g_tre.inf[i].flag_anim_kind, sizeof(BOOL), 1, file2);
			fwrite(&g_tre.inf[i].pt, sizeof(POINT), 1, file2);
			fwrite(&g_tre.inf[i].idxEffect, sizeof(int), 1, file2);
			fwrite(&g_tre.inf[i].idxWave, sizeof(int), 1, file2);
			fwrite(&g_tre.inf[i].idxFlag, sizeof(int), 1, file2);
		}
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_Treasure_Bin

// f[^ pc.dat ɕۑ
bool Save_PC_Bin(char *filename)
{
	FILE *file2;
	int	i,len,size;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_pc) / sizeof(g_tag_pc[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	len = strlen(g_pc.name) + 1;
	Fwrite_Tag(file2, g_tag_pc, 0, sizeof(int) + len);
	fwrite(&len, sizeof(int), 1, file2);
	fwrite(g_pc.name, sizeof(char), len, file2);
	size = sizeof(int) * 4 + sizeof(POINT) * 3 + sizeof(ABILITY);
	Fwrite_Tag(file2, g_tag_pc, 1, size);
	fwrite(&g_pc.move_speed, sizeof(int), 1, file2);
	fwrite(&g_pc.view, sizeof(POINT), 1, file2);
	fwrite(&g_pc.pos, sizeof(POINT), 1, file2);
	fwrite(&g_pc.posBm, sizeof(POINT), 1, file2);
	fwrite(&g_pc.idxDir, sizeof(int), 1, file2);
	fwrite(&g_pc.level, sizeof(int), 1, file2);
	fwrite(&g_pc.ability, sizeof(ABILITY), 1, file2);
	fwrite(&g_pc.damagePoison, sizeof(int), 1, file2);
	size = 0;
	for(i=0; i<2; i++){
		size += strlen(g_pc.img[i].filenameBm) + 1;
	}
	size += (sizeof(int) * 9 + sizeof(BOOL)) * 2;
	size += (sizeof(int) * 2 * 4);
	Fwrite_Tag(file2, g_tag_pc, 2, size);
	for(i=0; i<2; i++){
		len = strlen(g_pc.img[i].filenameBm) + 1;
		fwrite(&len, sizeof(int), 1, file2);
		fwrite(g_pc.img[i].filenameBm, sizeof(char), len, file2);
		fwrite(&g_pc.img[i].xBm, sizeof(int), 1, file2);
		fwrite(&g_pc.img[i].yBm, sizeof(int), 1, file2);
		fwrite(&g_pc.img[i].widthBm, sizeof(int), 1, file2);
		fwrite(&g_pc.img[i].heightBm, sizeof(int), 1, file2);
		fwrite(&g_pc.img[i].flag_alpha, sizeof(int), 1, file2);
		fwrite(&g_pc.img[i].flag_colorkey, sizeof(BOOL), 1, file2);
		fwrite(&g_pc.img[i].colorkey_red, sizeof(int), 1, file2);
		fwrite(&g_pc.img[i].colorkey_green, sizeof(int), 1, file2);
		fwrite(&g_pc.img[i].colorkey_blue, sizeof(int), 1, file2);
	}
	fwrite(g_pc.img_pos_idx, sizeof(int), 2 * 4, file2);
	Fwrite_Tag(file2, g_tag_pc, 3, sizeof(int) * EQUIP_NUM);
	fwrite(g_pc.idxEquipment, sizeof(int), EQUIP_NUM, file2);
	Fwrite_Tag(file2, g_tag_pc, 4, sizeof(int));
	fwrite(&g_pc.numItemKindMax, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_pc, 5, sizeof(int));
	fwrite(&g_pc.numItemKind, sizeof(int), 1, file2);
	if(g_pc.item){
		Fwrite_Tag(file2, g_tag_pc, 6, sizeof(ITEM3) * g_pc.numItemKind);
		fwrite(g_pc.item, sizeof(ITEM3), g_pc.numItemKind, file2);
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_PC_Bin

// f[^ npc_list.dat ɕۑ
bool Save_NPC_Bin(char *filename)
{
	FILE	*file2;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_npc) / sizeof(g_tag_npc[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_npc, 0, sizeof(int));
	fwrite(&g_npc.num, sizeof(int), 1, file2);
	if(g_npc.inf){
		int i,len,size = 0;
		for(i=0; i<g_npc.num; i++){
			size += sizeof(int) * 13;
			size += sizeof(BOOL) * 2;
			size += sizeof(POINT) * 4;
			size += sizeof(int) * 2 * 4;
			len = strlen(g_npc.inf[i].img.filenameBm) + 1;
			size += len;
		}
		Fwrite_Tag(file2, g_tag_npc, 1, size);
		for(i=0; i<g_npc.num; i++){
			fwrite(&g_npc.inf[i].typeMove, sizeof(int), 1, file2);
			fwrite(&g_npc.inf[i].idxDir, sizeof(int), 1, file2);
			fwrite(&g_npc.inf[i].flag_show, sizeof(BOOL), 1, file2);
			fwrite(&g_npc.inf[i].move_speed, sizeof(int), 1, file2);
			fwrite(&g_npc.inf[i].posBm, sizeof(POINT), 1, file2);
			fwrite(&g_npc.inf[i].posNow, sizeof(POINT), 1, file2);
			fwrite(&g_npc.inf[i].posCenter, sizeof(POINT), 1, file2);
			fwrite(&g_npc.inf[i].areaMove, sizeof(POINT), 1, file2);
			fwrite(&g_npc.inf[i].idxFlag, sizeof(int), 1, file2);
			len = strlen(g_npc.inf[i].img.filenameBm) + 1;
			fwrite(&len, sizeof(int), 1, file2);
			fwrite(g_npc.inf[i].img.filenameBm, sizeof(char), len, file2);
			fwrite(&g_npc.inf[i].img.xBm, sizeof(int), 1, file2);
			fwrite(&g_npc.inf[i].img.yBm, sizeof(int), 1, file2);
			fwrite(&g_npc.inf[i].img.widthBm, sizeof(int), 1, file2);
			fwrite(&g_npc.inf[i].img.heightBm, sizeof(int), 1, file2);
			fwrite(&g_npc.inf[i].img.flag_alpha, sizeof(int), 1, file2);
			fwrite(&g_npc.inf[i].img.flag_colorkey, sizeof(BOOL), 1, file2);
			fwrite(&g_npc.inf[i].img.colorkey_red, sizeof(int), 1, file2);
			fwrite(&g_npc.inf[i].img.colorkey_green, sizeof(int), 1, file2);
			fwrite(&g_npc.inf[i].img.colorkey_blue, sizeof(int), 1, file2);
			fwrite(g_npc.inf[i].img_pos_idx, sizeof(int), 2 * 4, file2);
		}
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_NPC_Bin

// f[^ scene?.dat ɕۑ
bool Save_Scene_Bin(char *filename)
{
	FILE	*file2;
	int		i,j,len,size;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_scene) / sizeof(g_tag_scene[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_scene, 0, sizeof(int));
	fwrite(&g_sn.kindScene, sizeof(int), 1, file2);
	len = strlen(g_sn.scene_name) + 1;
	Fwrite_Tag(file2, g_tag_scene, 1, sizeof(int) + len);
	fwrite(&len, sizeof(int), 1, file2);
	fwrite(g_sn.scene_name, sizeof(char), len, file2);
	len = strlen(g_sn.filenameMapData) + 1;
	Fwrite_Tag(file2, g_tag_scene, 2, sizeof(int) + len);
	fwrite(&len, sizeof(int), 1, file2);
	fwrite(g_sn.filenameMapData, sizeof(char), len, file2);
	len = strlen(g_sn.filenameBgMapChip) + 1;
	Fwrite_Tag(file2, g_tag_scene, 3, sizeof(int) + len);
	fwrite(&len, sizeof(int), 1, file2);
	fwrite(g_sn.filenameBgMapChip, sizeof(char), len, file2);
	len = strlen(g_sn.imginfLyerMapChip.name) + 1;
	size = sizeof(int) * 5 + sizeof(BOOL) + len;
	Fwrite_Tag(file2, g_tag_scene, 4, size);
	fwrite(&len, sizeof(int), 1, file2);
	fwrite(g_sn.imginfLyerMapChip.name, sizeof(char), len, file2);
	fwrite(&g_sn.imginfLyerMapChip.flag_alpha, sizeof(int), 1, file2);
	fwrite(&g_sn.imginfLyerMapChip.flag_colorkey, sizeof(BOOL), 1, file2);
	fwrite(&g_sn.imginfLyerMapChip.colorkey_red, sizeof(int), 1, file2);
	fwrite(&g_sn.imginfLyerMapChip.colorkey_green, sizeof(int), 1, file2);
	fwrite(&g_sn.imginfLyerMapChip.colorkey_blue, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_scene, 5, sizeof(int));
	fwrite(&g_sn.idxMidi, sizeof(int), 1, file2);
	if(g_sn.scene_change){
		Fwrite_Tag(file2, g_tag_scene, 6, sizeof(int));
		fwrite(&g_sn.scene_change_num, sizeof(int), 1, file2);
		Fwrite_Tag(file2, g_tag_scene, 7, sizeof(SCENECHANGE) * g_sn.scene_change_num);
		fwrite(g_sn.scene_change, sizeof(SCENECHANGE), g_sn.scene_change_num, file2);
	}
	if(g_sn.npc_index){
		Fwrite_Tag(file2, g_tag_scene, 8, sizeof(int));
		fwrite(&g_sn.npc_index_num, sizeof(int), 1, file2);
		Fwrite_Tag(file2, g_tag_scene, 9, sizeof(int) * g_sn.npc_index_num);
		fwrite(g_sn.npc_index, sizeof(int), g_sn.npc_index_num, file2);
	}
	if(g_sn.tre_index){
		Fwrite_Tag(file2, g_tag_scene, 10, sizeof(int));
		fwrite(&g_sn.tre_index_num, sizeof(int), 1, file2);
		Fwrite_Tag(file2, g_tag_scene, 11, sizeof(int) * g_sn.tre_index_num);
		fwrite(g_sn.tre_index, sizeof(int), g_sn.tre_index_num, file2);
	}
	if(g_sn.battle){
		Fwrite_Tag(file2, g_tag_scene, 12, sizeof(int));
		fwrite(&g_sn.battle_num, sizeof(int), 1, file2);
		Fwrite_Tag(file2, g_tag_scene, 13, sizeof(BATTLE) * g_sn.battle_num);
		fwrite(g_sn.battle, sizeof(BATTLE), g_sn.battle_num, file2);
		Fwrite_Tag(file2, g_tag_scene, 14, sizeof(BATTLEMAP));
		fwrite(&g_sn.battle_map, sizeof(BATTLEMAP), 1, file2);
	}
	if(strcmp(g_sn.filenameMapAnim, "")){
		len = strlen(g_sn.filenameMapAnim) + 1;
		Fwrite_Tag(file2, g_tag_scene, 15, sizeof(int) + len);
		fwrite(&len, sizeof(int), 1, file2);
		fwrite(g_sn.filenameMapAnim, sizeof(char), len, file2);
		Fwrite_Tag(file2, g_tag_scene, 16, sizeof(MAPANIM));
		fwrite(&g_sn.map_anim, sizeof(MAPANIM), 1, file2);
	}
	Fwrite_Tag(file2, g_tag_scene, 17, sizeof(int));
	fwrite(&g_sn.event_pos_num, sizeof(int), 1, file2);
	if(g_sn.event_pos){
		Fwrite_Tag(file2, g_tag_scene, 18, sizeof(EVENTPOS) * g_sn.event_pos_num);
		fwrite(g_sn.event_pos, sizeof(EVENTPOS), g_sn.event_pos_num, file2);
	}
	Fwrite_Tag(file2, g_tag_scene, 19, sizeof(int));
	fwrite(&g_sn.evt_cmd_num, sizeof(int), 1, file2);
	if(g_sn.evt_cmd){
		Fwrite_Tag(file2, g_tag_scene, 20, sizeof(int) * g_sn.evt_cmd_num);
		for(i=0; i<g_sn.evt_cmd_num; i++){
			fwrite(&g_sn.evt_cmd[i].num, sizeof(int), 1, file2);
		}
		size = 0;
		for(i=0; i<g_sn.evt_cmd_num; i++){
			if(g_sn.evt_cmd[i].str){
				for(j=0; j<g_sn.evt_cmd[i].num; j++){
					if(g_sn.evt_cmd[i].str[j]){
						len = strlen(g_sn.evt_cmd[i].str[j]) + 1;
						size += (sizeof(int) + len);
					}
				}
			}
		}
		Fwrite_Tag(file2, g_tag_scene, 21, size);
		for(i=0; i<g_sn.evt_cmd_num; i++){
			if(g_sn.evt_cmd[i].str){
				for(j=0; j<g_sn.evt_cmd[i].num; j++){
					if(g_sn.evt_cmd[i].str[j]){
						len = strlen(g_sn.evt_cmd[i].str[j]) + 1;
						fwrite(&len, sizeof(int), 1, file2);
						fwrite(g_sn.evt_cmd[i].str[j], sizeof(char), len, file2);
					}
				}
			}
		}
	}
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_Scene_Bin

// {ݒۑ
bool Save_Setting_Bin(char *filename)
{
	FILE *file2;
	int  i,len,size;
	
	if(GetFileAttributes(filename) != -1){
		int res = MessageBox(GetFocus(), "̃t@C݂܂A㏑܂H", filename, MB_YESNO | MB_SYSTEMMODAL);
		if(res == IDNO){
			return 0;
		}
	}
	
	if((file2=fopen(filename,"wb")) == NULL){
		MessageBox(GetFocus(), "t@C쐬ł܂", MYWNDTITLE, MB_ICONSTOP);
		return 0;
	}
	
	int tag_num = sizeof(g_tag_setting) / sizeof(g_tag_setting[0]);
	fwrite(&tag_num, sizeof(int), 1, file2);
	len = strlen(g_set.title) + 1;
	Fwrite_Tag(file2, g_tag_setting, 0, sizeof(int) + len);
	fwrite(&len, sizeof(int), 1, file2);
	fwrite(g_set.title, sizeof(char), len, file2);
	size = sizeof(int) * 5 + sizeof(BOOL) + len;
	Fwrite_Tag(file2, g_tag_setting, 1, size);
	fwrite(&len, sizeof(int), 1, file2);
	fwrite(g_set.img_focus.name, sizeof(char), len, file2);
	fwrite(&g_set.img_focus.flag_alpha, sizeof(int), 1, file2);
	fwrite(&g_set.img_focus.flag_colorkey, sizeof(BOOL), 1, file2);
	fwrite(&g_set.img_focus.colorkey_red, sizeof(int), 1, file2);
	fwrite(&g_set.img_focus.colorkey_green, sizeof(int), 1, file2);
	fwrite(&g_set.img_focus.colorkey_blue, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 2, sizeof(int));
	fwrite(&g_set.effect_arrow_talk, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 3, sizeof(int));
	fwrite(&g_set.effect_arrow_menu1, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 4, sizeof(int));
	fwrite(&g_set.effect_arrow_menu2, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 5, sizeof(int));
	fwrite(&g_set.effect_bare, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 6, sizeof(int));
	fwrite(&g_set.wave_bare, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 7, sizeof(int) * 3);
	fwrite(&g_set.flag_wave_battle, sizeof(int), 1, file2);
	fwrite(&g_set.wave_get, sizeof(int), 1, file2);
	fwrite(&g_set.wave_level_up, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 8, sizeof(int));
	fwrite(&g_set.wave_poison, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 9, sizeof(int));
	fwrite(&g_set.wave_equip_set, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 10, sizeof(int));
	fwrite(&g_set.wave_equip_remove, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 11, sizeof(int));
	fwrite(&g_set.midi_level_up, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 12, sizeof(int));
	fwrite(&g_set.midi_gameover, sizeof(int), 1, file2);
	len = strlen(g_set.denomi_name) + 1;
	Fwrite_Tag(file2, g_tag_setting, 13, sizeof(int) + len);
	fwrite(&len, sizeof(int), 1, file2);
	fwrite(g_set.denomi_name, sizeof(char), len, file2);
	Fwrite_Tag(file2, g_tag_setting, 14, sizeof(int));
	fwrite(&g_set.line_thick, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 15, sizeof(int));
	fwrite(&g_set.flag_battle_alpha, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 16, sizeof(int));
	fwrite(&g_set.flag_back_bmp, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 17, sizeof(int));
	fwrite(&g_set.alpha_select, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 18, sizeof(int) * 3);
	fwrite(&g_set.rgb_line.red, sizeof(int), 1, file2);
	fwrite(&g_set.rgb_line.green, sizeof(int), 1, file2);
	fwrite(&g_set.rgb_line.blue, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 19, sizeof(int) * 3);
	fwrite(&g_set.rgb_back.red, sizeof(int), 1, file2);
	fwrite(&g_set.rgb_back.green, sizeof(int), 1, file2);
	fwrite(&g_set.rgb_back.blue, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 20, sizeof(int) * 3);
	fwrite(&g_set.rgb_battle_item.red, sizeof(int), 1, file2);
	fwrite(&g_set.rgb_battle_item.green, sizeof(int), 1, file2);
	fwrite(&g_set.rgb_battle_item.blue, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 21, sizeof(int));
	fwrite(&g_set.alpha_battle_item, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 22, sizeof(int) * 3);
	fwrite(&g_set.rgb_back_talk.red, sizeof(int), 1, file2);
	fwrite(&g_set.rgb_back_talk.green, sizeof(int), 1, file2);
	fwrite(&g_set.rgb_back_talk.blue, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 23, sizeof(int));
	fwrite(&g_set.fade_max_talk, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 24, sizeof(int));
	fwrite(&g_set.flag_talk_face, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 25, sizeof(int));
	fwrite(&g_set.talk_y, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 26, sizeof(int));
	fwrite(&g_set.poison_interval, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 27, sizeof(int));
	fwrite(&g_set.move_interval_pc, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 28, sizeof(int));
	fwrite(&g_set.move_interval_npc, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 29, sizeof(int));
	fwrite(&g_set.no_scroll_area, sizeof(POINT), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 30, sizeof(int));
	fwrite(&g_set.straight_max, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 31, sizeof(int));
	fwrite(&g_set.game_speed, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 32, sizeof(int));
	fwrite(&g_set.fade_speed, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 33, sizeof(int));
	fwrite(&g_set.turn_speed, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 34, sizeof(int));
	fwrite(&g_set.e_attack_speed, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 35, sizeof(int));
	fwrite(&g_set.damage_speed, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 36, sizeof(int));
	fwrite(&g_set.e_damage_speed, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 37, sizeof(int));
	fwrite(&g_set.focus_speed, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 38, sizeof(int));
	fwrite(&g_set.letter_speed, sizeof(int), 1, file2);
	len = strlen(g_set.font_name) + 1;
	Fwrite_Tag(file2, g_tag_setting, 39, sizeof(int) + len);
	fwrite(&len, sizeof(int), 1, file2);
	fwrite(g_set.font_name, sizeof(char), len, file2);
	Fwrite_Tag(file2, g_tag_setting, 40, sizeof(int));
	fwrite(&g_set.font_weight, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 41, sizeof(int) * 3 * 9);
	for(i=0; i<9; i++){
		fwrite(&g_set.font_color[i].red, sizeof(int), 1, file2);
		fwrite(&g_set.font_color[i].green, sizeof(int), 1, file2);
		fwrite(&g_set.font_color[i].blue, sizeof(int), 1, file2);
	}
	Fwrite_Tag(file2, g_tag_setting, 42, sizeof(int));
	fwrite(&g_set.event_font_size, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 43, sizeof(int));
	fwrite(&g_set.talk_font_size, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 44, sizeof(int));
	fwrite(&g_set.ability_max, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 45, sizeof(int));
	fwrite(&g_set.item_own_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 46, sizeof(float));
	fwrite(&g_set.item_sell_rate, sizeof(float), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 47, sizeof(int));
	fwrite(&g_set.buy_disp_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 48, sizeof(int));
	fwrite(&g_set.sell_disp_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 49, sizeof(int));
	fwrite(&g_set.menu_disp_num1, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 50, sizeof(int));
	fwrite(&g_set.menu_disp_num2, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 51, sizeof(int));
	fwrite(&g_set.battle_disp_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 52, sizeof(int));
	fwrite(&g_set.save_disp_num, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 53, sizeof(int));
	fwrite(&g_set.battle_item_y, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 54, sizeof(int));
	fwrite(&g_set.battle_wait1, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 55, sizeof(int));
	fwrite(&g_set.battle_wait2, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 56, sizeof(int));
	fwrite(&g_save_max, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 57, sizeof(int));
	fwrite(&g_set.menu_width1, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 58, sizeof(int));
	fwrite(&g_set.menu_width2, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 59, sizeof(int));
	fwrite(&g_set.menu_width3, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 60, sizeof(int));
	fwrite(&g_set.item_height, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 61, sizeof(int));
	fwrite(&g_set.fade_inc_monster, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 62, sizeof(int));
	fwrite(&g_set.fade_inc_talk, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 63, sizeof(int));
	fwrite(&g_set.vol_all, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 64, sizeof(int));
	fwrite(&g_set.vol_bgm, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 65, sizeof(int));
	fwrite(&g_set.vol_sound, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 66, sizeof(int));
	fwrite(&g_set.key_interval, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 67, sizeof(int));
	fwrite(&g_set.talk_margin, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 68, sizeof(POINT));
	fwrite(&g_set.pos_menu_item, sizeof(POINT), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 69, sizeof(int));
	fwrite(&g_set.critical_rate, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 70, sizeof(int));
	fwrite(&g_set.ampl_damage, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 71, sizeof(int));
	fwrite(&g_set.ampl_damage_crt, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 72, sizeof(int));
	fwrite(&g_set.dist_enemy_attack, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 73, sizeof(int));
	fwrite(&g_set.effect_wave_crt, sizeof(int), 1, file2);
	Fwrite_Tag(file2, g_tag_setting, 74, sizeof(int));
	fwrite(&g_set.vol_sound_crt, sizeof(int), 1, file2);
	
	if(fclose(file2)){
		return 0;
	}
	
	return 1;
}// Save_Setting_Bin
